=== modified file 'INSTALL'
--- INSTALL	2005-10-19 07:04:01 +0000
+++ INSTALL	2007-04-04 06:17:54 +0000
@@ -16,6 +16,9 @@
 Installation
 ------------
 
+When upgrading using setup.py, it is recommended that you first delete the
+bzrlib directory from the install target.
+
 To install bzr as a user, run
 
   python setup.py install --home ~ 
@@ -24,3 +27,6 @@
 
   python setup.py install
 
+For more information on installation, see
+http://bazaar-vcs.org/InstallationFaq
+or write to bazaar@lists.canonical.com.

=== modified file 'NEWS'
--- NEWS	2007-04-04 22:21:23 +0000
+++ NEWS	2007-04-05 09:51:17 +0000
@@ -2,9 +2,12 @@
 
   IMPROVEMENTS:
 
+    * Merge directives can now be supplied as input to `merge` and `pull`,
+      like bundles can.  (Aaron Bentley)
+
     * Tags are now included in logs, that use the default log 
       formatter. (Erik Bågfors)
-      
+
   INTERNALS:
 
     * bzrlib API compatability with 0.8 has been dropped, cleaning up some
@@ -19,8 +22,29 @@
     * Deprecate Branch.get_root_id() because branches don't have root ids,
       rather than fixing bug #96847.  (Aaron Bentley)
 
+    * WorkingTree.apply_inventory_delta provides a better alternative to
+      WorkingTree._write_inventory.  (Aaron Bentley)
+
+    * Convenience method TestCase.expectFailure ensures that known failures
+      do not silently pass.  (Aaron Bentley)
+
+    * New SmartServer hooks facility. There are two initial hooks documented
+      in bzrlib.transport.smart.SmartServerHooks. The two initial hooks allow
+      plugins to execute code upon server startup and shutdown.
+      (Robert Collins).
+
+    * SmartServer in standalone mode will now close its listening socket
+      when it stops, rather than waiting for garbage collection. This primarily
+      fixes test suite hangs when a test tries to connect to a shutdown server.
+      It may also help improve behaviour when dealing with a server running
+      on a specific port (rather than dynamically assigned ports).
+      (Robert Collins)
+ 
   BUGFIXES:
 
+    * Don't fail bundle selftest if email has 'two' embedded.  
+      (#98510, Ian Clatworthy)
+
     * Remove ``--verbose`` from ``bzr bundle``. It didn't work anyway.
       (Robert Widhopf-Fenk, #98591)
 
@@ -28,6 +52,9 @@
       properly and is no longer beneficial. Fixes #53675 and #43486.
       (Robert Collins)
 
+    * Don't produce encoding error when adding duplicate files.
+      (Aaron Bentley)
+
   TESTING:
 
     * Added ``bzrlib.strace.strace`` which will strace a single callable and
@@ -59,13 +86,46 @@
       (Robert Collins, Andrew Bennetts)
 
 
-bzr 0.15 (not finalised)
+bzr 0.15 2007-04-01
+
+  BUGFIXES:
+
+    * Handle incompatible repositories as a user issue when fetching.
+      (Aaron Bentley)
+
+    * Don't give a recommendation to upgrade when branching or 
+      checking out a branch that contains an old-format working tree.
+      (Martin Pool)
+
+bzr 0.15rc3  2007-03-26
+
+  CHANGES:
+ 
+    * A warning is now displayed when opening working trees in older 
+      formats, to encourage people to upgrade to WorkingTreeFormat4.
+      (Martin Pool)
+
+  IMPROVEMENTS:
+
+    * HTTP redirections are now taken into account when a branch (or a
+      bundle) is accessed for the first time. A message is issued at each
+      redirection to inform the user. In the past, http redirections were
+      silently followed for each request which significantly degraded the
+      performances. The http redirections are not followed anymore by
+      default, instead a RedirectRequested exception is raised. For bzrlib
+      users needing to follow http redirections anyway,
+      bzrlib.transport.do_catching_redirections provide an easy transition
+      path.  (vila)
 
   INTERNALS:
 
     * Added ``ReadLock.temporary_write_lock()`` to allow upgrading an OS read
       lock to an OS write lock. Linux can do this without unlocking, Win32
       needs to unlock in between. (John Arbash Meinel)
+ 
+    * New parameter ``recommend_upgrade`` to BzrDir.open_workingtree 
+      to silence (when false) warnings about opening old formats.
+      (Martin Pool)
 
     * Fix minor performance regression with bzr-0.15 on pre-dirstate
       trees. (We were reading the working inventory too many times).
@@ -94,7 +154,20 @@
 
     * ``bzr checkout source`` should create a local branch in the same
       format as source. (John Arbash Meinel, #93854)
+
+    * ``bzr commit`` with a kind change was failing to update the
+      last-changed-revision for directories.  The
+      InventoryDirectory._unchanged only looked at the parent_id and name,
+      ignoring the fact that the kind could have changed, too.
+      (John Arbash Meinel, #90111)
+
+    * ``bzr mv dir/subdir other`` was incorrectly updating files inside
+      the directory. So that there was a chance it would break commit,
+      etc. (John Arbash Meinel, #94037)
  
+    * Correctly handles mutiple permanent http redirections.
+     (vila, #88780)
+
 
 bzr 0.15rc2  2007-03-14
 
@@ -2214,6 +2287,24 @@
       bzr branch it cannot understand. This allows for precise
       handling of such circumstances.
 
+    * Remove RevisionReference class; Revision.parent_ids is now simply a
+      list of their ids and parent_sha1s is a list of their corresponding
+      sha1s (for old branches only at the moment.)
+
+    * New method-object style interface for Commit() and Fetch().
+
+    * Renamed Branch.last_patch() to Branch.last_revision(), since
+      we call them revisions not patches.
+
+    * Move copy_branch to bzrlib.clone.copy_branch.  The destination
+      directory is created if it doesn't exist.
+
+    * Inventories now identify the files which were present by 
+      giving the revision *of that file*.
+
+    * Inventory and Revision XML contains a version identifier.  
+      This must be consistent with the overall branch version
+      but allows for more flexibility in future upgrades.
 
   TESTING:
 

=== removed file 'NEWS.developers'
--- NEWS.developers	2005-10-13 07:30:57 +0000
+++ NEWS.developers	1970-01-01 00:00:00 +0000
@@ -1,25 +0,0 @@
-DEVELOPMENT HEAD
-
- * Properties can be set on Revisions by passing 'revprops=' to
-   Branch.commit(), and retrieved by looking at Revision.properties.
-
-bzr 0.1
-
- * Remove RevisionReference class; Revision.parent_ids is now simply a
-   list of their ids and parent_sha1s is a list of their corresponding
-   sha1s (for old branches only at the moment.)
-
- * New method-object style interface for Commit() and Fetch().
-
- * Renamed Branch.last_patch() to Branch.last_revision(), since
-   we call them revisions not patches.
-
- * Move copy_branch to bzrlib.clone.copy_branch.  The destination
-   directory is created if it doesn't exist.
-
- * Inventories now identify the files which were present by 
-   giving the revision *of that file*.
-
- * Inventory and Revision XML contains a version identifier.  
-   This must be consistent with the overall branch version
-   but allows for more flexibility in future upgrades.

=== modified file 'TODO'
--- TODO	2006-10-11 01:17:15 +0000
+++ TODO	2007-04-04 06:17:31 +0000
@@ -1,467 +1,4 @@
-.. -*- mode: indented-text; compile-command: "make -C doc" -*-
-
-
-*******************
-Things to do in bzr
-*******************
-
-
-See also various low-level TODOs in the source code.  Try looking in
-the list archive or on gmane.org for previous discussion of these
-issues.
-
-These are classified by approximate size: an hour or less, a day or
-less, and several days or more.
-
-
-Small things
-------------
-
-* Fix tests so that import errors caused by modules don't produce false reports
-  that the tests themselves don't exist.
-
-* Fix tests so that one test failure doesn't prevent other tests from running
-
-* print a message at the end of running the tests telling them that the
-  test log and output exists but can be removed
-
-* tests for running the commit editor, and fix problem of not passing in 
-  multiple arguments
-
-* Merging add of a new file clashing with an existing file doesn't
-  work; add gets an error that it's already versioned and the merge
-  aborts.
-
-* Merge should ignore the destination's working directory, otherwise
-  we get an error about the statcache when pulling from a remote
-  branch.
-
-* Add of a file that was present in the base revision should put back
-  the previous file-id.
-
-* Not sure I'm happy with needing to pass a root id to EmptyTree;
-  comparing anything against an EmptyTree with no root should have the
-  same effect(?)
-
-* Handle diff of files which do not have a trailing newline; probably
-  requires patching difflib to get it exactly right, or otherwise
-  calling out to GNU diff.
-
-* Should be able to copy files between branches to preserve their
-  file-id (and perhaps eventually parentage.)
-
-* -r option should take a revision-id as well as a revno.
-
-* ``bzr info`` should count only people with distinct email addresses as
-  different committers.  (Or perhaps only distinct userids?)
-
-* On Windows, command-line arguments should be `glob-expanded`__,
-  because the shell doesn't do this.  However, there are probably some
-  commands where this shouldn't be done, such as 'bzr ignore', because
-  we want to accept globs.
-
-* ``bzr ignore`` command that just adds a line to the ``.bzrignore`` file
-  and makes it versioned.  Fix this to break symlinks.
-
-* Any useful sanity checks in 'bzr ignore'?  Perhaps give a warning if
-  they try to add a single file which is already versioned, or if they
-  add a pattern which already exists, or if it looks like they gave an
-  unquoted glob.
-
-__ http://mail.python.org/pipermail/python-list/2001-April/037847.html
-
-* Separate read and write version checks?
-
-* ``bzr status DIR`` should give status on all files under that
-  directory.
-
-* ``bzr log DIR`` should give changes to any files within DIR; at the
-  moment it only lists things which modify the specific named file
-  (and not its contents)
-
-* ``bzr inventory -r REV`` and perhaps unify this with ``bzr ls``,
-  giving options to display ids, types, etc.
-
-* RemoteBranch could maintain a cache either in memory or on disk.  We
-  know more than an external cache might about which files are
-  immutable and which can vary.  On the other hand, it's much simpler
-  to just use an external proxy cache.
-
-  Perhaps ~/.bzr/http-cache.  Baz has a fairly simple cache under
-  ~/.arch-cache, containing revision information encoded almost as a
-  bunch of archives.  Perhaps we could simply store full paths.
-
-* Maybe also store directories in the statcache so that we can quickly
-  identify that they still exist.
-
-* Diff should show timestamps; for files from the working directory we
-  can use the file itself; for files from a revision we should use the
-  commit time of the revision.
-
-* Perhaps split command infrastructure from the actual command
-  definitions.
-
-* Cleaner support for negative boolean options like --no-recurse.
-
-* Statcache should possibly map all file paths to / separators
-
-* quotefn doubles all backslashes on Windows; this is probably not the
-  best thing to do.  What would be a better way to safely represent
-  filenames?  Perhaps we could doublequote things containing spaces,
-  on the principle that filenames containing quotes are unlikely?
-  Nice for humans; less good for machine parsing.
-
-* Patches should probably use only forward slashes, even on Windows,
-  otherwise Unix patch can't apply them. (?)
-
-* Branch.update_revisions() inefficiently fetches revisions from the
-  remote server twice; once to find out what text and inventory they
-  need and then again to actually get the thing.  This is a bit
-  inefficient.
-
-  One complicating factor here is that we don't really want to have
-  revisions present in the revision-store until all their constituent
-  parts are also stored.
-
-  The basic problem is that RemoteBranch.get_revision() and similar
-  methods return object, but what we really want is the raw XML, which
-  can be popped into our own store.  That needs to be refactored.
-
-* Guard against repeatedly merging any particular patch.
-
-* More options for diff:
-
-  - diff two revisions of the same tree
-
-  - diff two different branches, optionally at different revisions
-
-  - diff a particular file in another tree against the corresponding
-    version in this tree (which should be the default if the second
-    parameter is a tree root)
-
-  - diff everything under a particular directory, in any of the above
-    ways
-
-  - diff two files inside the same tree, even if they have different
-    ids
-
-  - and, of course, tests for all this
-
-* Reproducible performance benchmark to measure whether performance is 
-  getting better or worse.
-
-* ``bzr log -m foo`` should perhaps error if nothing matches?
-
-* ``bzr diff -r 30 -r 40 foo.c`` or ``bzr diff -r30..40 foo.c``
-
-  If diffing between two branches then we probably want two -r
-  options, since the revisions don't form a range that can be
-  evaluated on either one.
-
-* bzr diff shouldn't diff binary files
-
-* setup.py install when run from a bzr tree should freeze the tree
-  revision-id into the installed bzr.
-
-* bzr script should trap ImportError and perhaps give a better error
-  message?
-
-* revert after a merge should possibly remove all the BASE/THIS/OTHER
-  files to get you back to where you were.
-
-* files that are added and then deleted are still reported as added
-
-* stores should raise KeyError, not IndexError
-
-* merging from a remote branch seems to sometimes raise errors not
-  present locally
-
-* should be possible to give a related branch when pulling from a
-  remote branch to make things faster
-
-* sometimes gives "conflicting add" even when the contents are in fact
-  the same???
-
-* BZRDIR should be in branch.py not __init__.py.
-
-* bzrlib.delta.compare_trees() shouldn't need to sort all of the result
-  lists, since they are being added in alphabetical order. Write tests
-  to guarantee this, and remove the sort() calls.
-
-Medium things
--------------
-
-* merge should add all revision and inventory XML to the local store.
-
-* check should give a warning for revisions that are named in the
-  chain but not actually present in the store.
-
-* remove anything outside of the branch implementation that directly
-  accesses the stores.
-
-* More efficient diff of only selected files.  We should be able to
-  just get the id for the selected files, look up their location and
-  diff just those files.  No need to traverse the entire inventories.
-
-* Fix up Inventory objects to represent root object as an entry.
-
-* Don't convert entire entry from ElementTree to an object when it is
-  read in, but rather wait until the program actually wants to know
-  about that node.
-
-* Extract changes from one revision to the next to a text form
-  suitable for transmission over email.
-
-* More test cases.
-
-  - ``missing`` command
-
-  - Selected-file commit
-
-  - Impossible selected-file commit: adding things in non-versioned
-    directories, crossing renames, etc.
-
-* Write a reproducible benchmark, perhaps importing various kernel versions.
-
-* Directly import diffs!  It seems a bit redundant to need to rescan
-  the directory to work out what files diff added/deleted/changed when
-  all the information is there in the diff in the first place.
-  Getting the exact behaviour for added/deleted subdirectories etc
-  might be hard.
-
-  At the very least we could run diffstat over the diff, or perhaps
-  read the status output from patch.  Just knowing which files might
-  be modified would be enough to guide the add and commit.
-
-  Given this we might be able to import patches at 1/second or better.
-
-* revfile compression.
-
-* Split inventory into per-directory files?
-
-* Fix ignore file parsing:
-
-  - fnmatch is not the same as unix patterns
-
-  - perhaps add extended globs from rsh/rsync
-
-  - perhaps a pattern that matches only directories or non-directories
-
-* Consider using Python logging library as well as/instead of
-  bzrlib.trace.
-
-* Commands should give some progress indication by default.
-
-  - But quieten this with ``--silent``.
-
-* Change to using gettext message localization.
-
-* Make a clearer separation between internal and external bzrlib
-  interfaces.  Make internal interfaces use protected names.  Write at
-  least some documentation for those APIs, probably as docstrings.
-
-  Consider using ZopeInterface definitions for the external interface;
-  I think these are already used in PyBaz.  They allow automatic
-  checking of the interface but may be unfamiliar to general Python
-  developers, so I'm not really keen.
-
-* Commands to dump out all command help into a manpage or HTML file or
-  whatever.
-
-* Handle symlinks in the working directory; at the very least it
-  should be possible for them to be present and ignored/unknown
-  without causing assertion failures.
-
-  Eventually symlinks should be versioned.
-
-* Allow init in a subdirectory to create a nested repository, but only
-  if the subdirectory is not already versioned.   Perhaps also require
-  a ``--nested`` to protect against confusion.
-
-* Branch names?
-
-* More test framework:
-
-  - Class that describes the state of a working tree so we can just
-    assert it's equal.
-
-* Try using XSLT to add some formatting to REST-generated HTML.  Or
-  maybe write a small Python program that specifies a header and foot
-  for the pages and calls into the docutils libraries.
-
-* --format=xml for log, status and other commands.
-
-* Attempting to explicitly add a file that's already added should give
-  a warning; however there should be no warning for directories (since
-  we scan for new children) or files encountered in a directory that's
-  being scanned.
-
-* Better handling of possible collisions on case-losing filesystems;
-  make sure a single file does not get added twice under different
-  names.
-
-* Clean up XML inventory:
-
-  - Use nesting rather than parent_id pointers.
-
-  - Hold the ElementTree in memory in the Inventory object and work
-    directly on that, rather than converting into Python objects every
-    time it is read in.  Probably still expose it through some kind of
-    object interface though, but perhaps that should just be a proxy
-    for the elements.
-
-  - Less special cases for the root directory.
-
-* Perhaps inventories should remember the revision in which each file
-  was last changed, as well as its current state?  This is a bit
-  redundant but might often be interested to know.
-
-* stat cache should perhaps only stat files as necessary, rather than
-  doing them all up-front.  On the other hand, that disallows the
-  optimization of stating them in inode order.
-
-* It'd be nice to pipeline multiple HTTP requests.  Often we can
-  predict what will be wanted in future: all revisions, or all texts
-  in a particular revision, etc.
-
-  urlgrabber's docs say they are working on batched downloads; we
-  could perhaps ride on that or just create a background thread (ew).
-
-* Paranoid mode where we never trust SHA-1 matches.
-
-* --dry-run mode for commit?  (Or maybe just run with
-  check-command=false?)
-
-* Generally, be a bit more verbose unless --silent is specified.
-
-* Function that finds all changes to files under a given directory;
-  perhaps log should use this if a directory is given.
-
-* XML attributes might have trouble with filenames containing \n and
-  \r.  Do we really want to support this?  I think perhaps not.
-
-* Unify smart_add and plain Branch.add(); perhaps smart_add should
-  just build a list of files to add and pass that to the regular add
-  function.
-
-* Function to list a directory, saying in which revision each file was
-  last modified.  Useful for web and GUI interfaces, and slow to
-  compute one file at a time.
-  
-  This will be done when we track file texts by referring to the
-  version that created them. 
-
-* Check locking is correct during merge-related operations.
-
-* Perhaps attempts to get locks should timeout after some period of
-  time, or at least display a progress message.
-
-* Don't pass around command classes but rather pass objects.  This'd
-  make it cleaner to construct objects wrapping external commands.
-
-* Track all merged-in revisions in a versioned add-only metafile.
-
-* ``uncommit`` command that removes a revision from the end of the
-  revision-history; just doing this is enough to remove the commit,
-  and a new commit will automatically be made against the
-  predecessor.  This can be repeated.
-
-  It only makes sense to delete from the tail of history.
-
-  This has been implemented, but it does not remove the texts from
-  the store.
-
-* ``bzrlib.lazy_import.lazy_import`` could check to see if a given
-  module has already been imported (look at ``sys.modules``). If it
-  has, then just import it directly, rather than creating a lazy
-  object.
-
-
-Large things
-------------
-
-* Generate annotations from current file relative to previous
-  annotations.
-
-  - Is it necessary to store any kind of annotation where data was
-    deleted?
-
-* Update revfile_ format and make it active:
-
-  - Texts should be identified by something keyed on the revision, not
-    an individual text-id.  This is much more useful for annotate I
-    think; we want to map back to the revision that last changed it.
-
-  - Access revfile revisions through the Tree/Store classes.
-
-  - Check them from check commands.
-
-  - Store annotations.
-
-.. _revfile: revfile.html
-
-* Hooks for pre-commit, post-commit, etc.
-
-  Consider the security implications; probably should not enable hooks
-  for remotely-fetched branches by default.
-
-* Pre-commit check.  If this hook is defined, it needs to be handled
-  specially: create a temporary directory containing the tree as it
-  will be after the commit.  This means excluding any ignored/unknown
-  files, and respecting selective commits.  Run the pre-commit check
-  (e.g. compile and run test suite) in there.
-
-  Possibly this should be done by splitting the commit function into
-  several parts (under a single interface).  It is already rather
-  large.  Decomposition:
-
-   - find tree modifications and prepare in-memory inventory
-
-   - export that inventory to a temporary directory
-
-   - run the test in that temporary directory
-
-   - if that succeeded, continue to actually finish the commit
-
-  What should be done with the text of modified files while this is
-  underway?  I don't think we want to count on holding them in memory
-  and we can't trust the working files to stay in one place so I
-  suppose we need to move them into the text store, or otherwise into
-  a temporary directory.
-
-  If the commit does not actually complete, we would rather the
-  content was not left behind in the stores.
-
-* Web interface
-
-* GUI (maybe in Python GTK+?)
-
-* C library interface
-
-* Expansion of $Id$ keywords within working files.  Perhaps do this in
-  exports first as a simpler case because then we don't need to deal
-  with removing the tags on the way back in.
-
-* ``bzr find``
-
-Selftest
---------
-
-* Write some benchmark tests
-
-* we could display the ids of some tests selected by time to rune, or cputime,
-  rusage. 
-
-* We could run tests multiple times and report deviation/slowest/fastest.
-
-* Gather lsprofile output for each test individually - log that somewhere.
-
-* Should plugins be able to offer benchmark tests ?
-
-CHANGESETS
-----------
-Ensure changeset command behaves properly w/revisions (e.g. 0)
-Figure out whether testament-related bug is my problem
-Get rid of the 'old' directory
-Bundle signatures
-What to do about ghost ancestors in remote branch that are present locally?
+For things to do in Bazaar development, see
+
+https://bugs.launchpad.net/bzr/
+https://blueprints.launchpad.net/bzr/

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2007-03-28 23:28:21 +0000
+++ bzrlib/branch.py	2007-04-04 05:19:38 +0000
@@ -54,6 +54,7 @@
                            NotBranchError, UninitializableFormat,
                            UnlistableStore, UnlistableBranch,
                            )
+from bzrlib.hooks import Hooks
 from bzrlib.symbol_versioning import (deprecated_function,
                                       deprecated_method,
                                       DEPRECATED_PARAMETER,
@@ -892,7 +893,7 @@
             control_files.unlock()
 
 
-class BranchHooks(dict):
+class BranchHooks(Hooks):
     """A dictionary mapping hook name to a list of callables for branch hooks.
     
     e.g. ['set_rh'] Is the list of items to be called when the
@@ -905,7 +906,7 @@
         These are all empty initially, because by default nothing should get
         notified.
         """
-        dict.__init__(self)
+        Hooks.__init__(self)
         # Introduced in 0.15:
         # invoked whenever the revision history has been set
         # with set_revision_history. The api signature is
@@ -944,20 +945,6 @@
         # and an empty branch recieves new_revno of 0, new_revid of None.
         self['post_uncommit'] = []
 
-    def install_hook(self, hook_name, a_callable):
-        """Install a_callable in to the hook hook_name.
-
-        :param hook_name: A hook name. See the __init__ method of BranchHooks
-            for the complete list of hooks.
-        :param a_callable: The callable to be invoked when the hook triggers.
-            The exact signature will depend on the hook - see the __init__ 
-            method of BranchHooks for details on each hook.
-        """
-        try:
-            self[hook_name].append(a_callable)
-        except KeyError:
-            raise errors.UnknownHook('branch', hook_name)
-
 
 # install the default hooks into the Branch class.
 Branch.hooks = BranchHooks()

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2007-04-04 19:28:02 +0000
+++ bzrlib/builtins.py	2007-04-05 09:51:17 +0000
@@ -569,6 +569,8 @@
             directory=None):
         from bzrlib.tag import _merge_tags_if_possible
         # FIXME: too much stuff is in the command class
+        revision_id = None
+        mergeable = None
         if directory is None:
             directory = u'.'
         try:
@@ -581,7 +583,8 @@
         reader = None
         if location is not None:
             try:
-                reader = bundle.read_bundle_from_url(location)
+                mergeable = bundle.read_mergeable_from_url(
+                    location)
             except errors.NotABundle:
                 pass # Continue on considering this url a Branch
 
@@ -596,8 +599,11 @@
                 self.outf.write("Using saved location: %s\n" % display_url)
                 location = stored_loc
 
-        if reader is not None:
-            install_bundle(branch_to.repository, reader)
+        if mergeable is not None:
+            if revision is not None:
+                raise errors.BzrCommandError(
+                    'Cannot use -r with merge directives or bundles')
+            revision_id = mergeable.install_revisions(branch_to.repository)
             branch_from = branch_to
         else:
             branch_from = Branch.open(location)
@@ -605,27 +611,26 @@
             if branch_to.get_parent() is None or remember:
                 branch_to.set_parent(branch_from.base)
 
-        rev_id = None
-        if revision is None:
-            if reader is not None:
-                rev_id = reader.target
-        elif len(revision) == 1:
-            rev_id = revision[0].in_history(branch_from).rev_id
-        else:
-            raise errors.BzrCommandError('bzr pull --revision takes one value.')
+        if revision is not None:
+            if len(revision) == 1:
+                revision_id = revision[0].in_history(branch_from).rev_id
+            else:
+                raise errors.BzrCommandError(
+                    'bzr pull --revision takes one value.')
 
         old_rh = branch_to.revision_history()
         if tree_to is not None:
-            result = tree_to.pull(branch_from, overwrite, rev_id,
+            result = tree_to.pull(branch_from, overwrite, revision_id,
                 delta._ChangeReporter(unversioned_filter=tree_to.is_ignored))
         else:
-            result = branch_to.pull(branch_from, overwrite, rev_id)
+            result = branch_to.pull(branch_from, overwrite, revision_id)
 
         result.report(self.outf)
         if verbose:
             from bzrlib.log import show_changed_revisions
             new_rh = branch_to.revision_history()
-            show_changed_revisions(branch_to, old_rh, new_rh, to_file=self.outf)
+            show_changed_revisions(branch_to, old_rh, new_rh,
+                                   to_file=self.outf)
 
 
 class cmd_push(Command):
@@ -2489,6 +2494,7 @@
             directory=None,
             ):
         from bzrlib.tag import _merge_tags_if_possible
+        other_revision_id = None
         if merge_type is None:
             merge_type = _mod_merge.Merge3Merger
 
@@ -2506,16 +2512,18 @@
 
         if branch is not None:
             try:
-                reader = bundle.read_bundle_from_url(branch)
+                mergeable = bundle.read_mergeable_from_url(
+                    branch)
             except errors.NotABundle:
                 pass # Continue on considering this url a Branch
             else:
-                conflicts = merge_bundle(reader, tree, not force, merge_type,
-                                         reprocess, show_base, change_reporter)
-                if conflicts == 0:
-                    return 0
-                else:
-                    return 1
+                if revision is not None:
+                    raise errors.BzrCommandError(
+                        'Cannot use -r with merge directives or bundles')
+                other_revision_id = mergeable.install_revisions(
+                    tree.branch.repository)
+                revision = [RevisionSpec.from_string(
+                    'revid:' + other_revision_id)]
 
         if revision is None \
                 or len(revision) < 1 or revision[0].needs_branch():
@@ -2536,9 +2544,14 @@
             branch = revision[0].get_branch() or branch
             if len(revision) == 1:
                 base = [None, None]
-                other_branch, path = Branch.open_containing(branch)
-                revno = revision[0].in_history(other_branch).revno
-                other = [branch, revno]
+                if other_revision_id is not None:
+                    other_branch = None
+                    path = ""
+                    other = None
+                else:
+                    other_branch, path = Branch.open_containing(branch)
+                    revno = revision[0].in_history(other_branch).revno
+                    other = [branch, revno]
             else:
                 assert len(revision) == 2
                 if None in revision:
@@ -2554,12 +2567,14 @@
                 base = [branch, revision[0].in_history(base_branch).revno]
                 other = [branch1, revision[1].in_history(other_branch).revno]
 
-        if tree.branch.get_parent() is None or remember:
+        if ((tree.branch.get_parent() is None or remember) and
+            other_branch is not None):
             tree.branch.set_parent(other_branch.base)
 
         # pull tags now... it's a bit inconsistent to do it ahead of copying
         # the history but that's done inside the merge code
-        _merge_tags_if_possible(other_branch, tree.branch)
+        if other_branch is not None:
+            _merge_tags_if_possible(other_branch, tree.branch)
 
         if path != "":
             interesting_files = [path]
@@ -2569,7 +2584,8 @@
         try:
             try:
                 conflict_count = _merge_helper(
-                    other, base, check_clean=(not force),
+                    other, base, other_rev_id=other_revision_id,
+                    check_clean=(not force),
                     merge_type=merge_type,
                     reprocess=reprocess,
                     show_base=show_base,
@@ -3495,7 +3511,8 @@
                   file_list=None, show_base=False, reprocess=False,
                   pull=False,
                   pb=DummyProgress(),
-                  change_reporter=None):
+                  change_reporter=None,
+                  other_rev_id=None):
     """Merge changes into a tree.
 
     base_revision
@@ -3551,7 +3568,10 @@
         merger.pp = ProgressPhase("Merge phase", 5, pb)
         merger.pp.next_phase()
         merger.check_basis(check_clean)
-        merger.set_other(other_revision)
+        if other_rev_id is not None:
+            merger.set_other_revision(other_rev_id, this_tree.branch)
+        else:
+            merger.set_other(other_revision)
         merger.pp.next_phase()
         merger.set_base(base_revision)
         if merger.base_rev_id == merger.other_rev_id:

=== modified file 'bzrlib/bundle/__init__.py'
--- bzrlib/bundle/__init__.py	2006-12-07 15:30:26 +0000
+++ bzrlib/bundle/__init__.py	2007-04-01 06:19:16 +0000
@@ -14,6 +14,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+from StringIO import StringIO
+
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 from bzrlib import (
@@ -21,16 +23,24 @@
     urlutils,
     )
 from bzrlib.bundle import serializer as _serializer
-from bzrlib.transport import get_transport as _get_transport
+from bzrlib.transport import (
+    do_catching_redirections,
+    get_transport,
+    )
 """)
+from bzrlib.trace import note
 
 
 def read_bundle_from_url(url):
-    """Read a bundle from a given URL.
-
-    :return: A BundleReader, may raise NotABundle if the target 
-            is not a proper bundle.
+    return read_mergeable_from_url(url, _do_directive=False)
+
+def read_mergeable_from_url(url, _do_directive=True):
+    """Read mergable object from a given URL.
+
+    :return: An object supporting get_target_revision.  Raises NotABundle if
+        the target is not a mergeable type.
     """
+    from bzrlib.merge_directive import MergeDirective
     url = urlutils.normalize_url(url)
     url, filename = urlutils.split(url, exclude_trailing_slash=False)
     if not filename:
@@ -42,9 +52,30 @@
     # Some transports cannot detect that we are trying to read a
     # directory until we actually issue read() on the handle.
     try:
-        t = _get_transport(url)
-        f = t.get(filename)
-        return _serializer.read_bundle(f)
+        transport = get_transport(url)
+
+        def get_bundle(transport):
+            return transport.get(filename)
+
+        def redirected_transport(transport, exception, redirection_notice):
+            note(redirection_notice)
+            url, filename = urlutils.split(exception.target,
+                                           exclude_trailing_slash=False)
+            if not filename:
+                raise errors.NotABundle('A directory cannot be a bundle')
+            return get_transport(url)
+
+        try:
+            f = do_catching_redirections(get_bundle, transport,
+                                         redirected_transport)
+        except errors.TooManyRedirections:
+            raise errors.NotABundle(str(url))
+
+        if _do_directive:
+            directive = MergeDirective.from_lines(f.readlines())
+            return directive
+        else:
+            return _serializer.read_bundle(f)
     except (errors.TransportError, errors.PathError), e:
         raise errors.NotABundle(str(e))
     except (IOError,), e:
@@ -56,4 +87,6 @@
         # StubSFTPServer does fail during get() (because of prefetch) 
         # so it has an opportunity to translate the error.
         raise errors.NotABundle(str(e))
-
+    except errors.NotAMergeDirective:
+        f.seek(0)
+        return _serializer.read_bundle(f)

=== modified file 'bzrlib/bundle/bundle_data.py'
--- bzrlib/bundle/bundle_data.py	2007-03-07 19:33:08 +0000
+++ bzrlib/bundle/bundle_data.py	2007-04-01 03:52:31 +0000
@@ -25,6 +25,7 @@
     osutils,
     )
 import bzrlib.errors
+from bzrlib.bundle import apply_bundle
 from bzrlib.errors import (TestamentMismatch, BzrError, 
                            MalformedHeader, MalformedPatches, NotABundle)
 from bzrlib.inventory import (Inventory, InventoryEntry,
@@ -432,6 +433,11 @@
                         ' (unrecognized action): %r' % action_line)
             valid_actions[action](kind, extra, lines)
 
+    def install_revisions(self, target_repo):
+        """Install revisions and return the target revision"""
+        apply_bundle.install_bundle(target_repo, self)
+        return self.target
+
 
 class BundleTree(Tree):
     def __init__(self, base_tree, revision_id):

=== modified file 'bzrlib/bundle/serializer/v08.py'
--- bzrlib/bundle/serializer/v08.py	2007-03-06 14:36:48 +0000
+++ bzrlib/bundle/serializer/v08.py	2007-03-16 15:14:40 +0000
@@ -29,7 +29,6 @@
 from bzrlib.osutils import pathjoin
 from bzrlib.progress import DummyProgress
 from bzrlib.revision import NULL_REVISION
-from bzrlib.rio import RioWriter, read_stanzas
 import bzrlib.ui
 from bzrlib.testament import StrictTestament
 from bzrlib.timestamp import (
@@ -529,7 +528,6 @@
                 self._next().next()
                 break
 
-
 class BundleInfo08(BundleInfo):
 
     def _update_tree(self, bundle_tree, revision_id):

=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2007-03-30 02:36:36 +0000
+++ bzrlib/bzrdir.py	2007-04-01 06:19:16 +0000
@@ -46,6 +46,7 @@
     registry,
     revision as _mod_revision,
     symbol_versioning,
+    ui,
     urlutils,
     xml4,
     xml5,
@@ -61,11 +62,17 @@
 from bzrlib.store.text import TextStore
 from bzrlib.store.versioned import WeaveStore
 from bzrlib.transactions import WriteTransaction
-from bzrlib.transport import get_transport
+from bzrlib.transport import (
+    do_catching_redirections,
+    get_transport,
+    )
 from bzrlib.weave import Weave
 """)
 
-from bzrlib.trace import mutter, note
+from bzrlib.trace import (
+    mutter,
+    note,
+    )
 from bzrlib.transport.local import LocalTransport
 
 
@@ -109,14 +116,32 @@
         source_repo_format.check_conversion_target(target_repo_format)
 
     @staticmethod
-    def _check_supported(format, allow_unsupported):
-        """Check whether format is a supported format.
-
-        If allow_unsupported is True, this is a no-op.
+    def _check_supported(format, allow_unsupported,
+        recommend_upgrade=True,
+        basedir=None):
+        """Give an error or warning on old formats.
+
+        :param format: may be any kind of format - workingtree, branch, 
+        or repository.
+
+        :param allow_unsupported: If true, allow opening 
+        formats that are strongly deprecated, and which may 
+        have limited functionality.
+
+        :param recommend_upgrade: If true (default), warn
+        the user through the ui object that they may wish
+        to upgrade the object.
         """
+        # TODO: perhaps move this into a base Format class; it's not BzrDir
+        # specific. mbp 20070323
         if not allow_unsupported and not format.is_supported():
             # see open_downlevel to open legacy branches.
             raise errors.UnsupportedFormatError(format=format)
+        if recommend_upgrade \
+            and getattr(format, 'upgrade_recommended', False):
+            ui.ui_factory.recommend_upgrade(
+                format.get_format_description(),
+                basedir)
 
     def clone(self, url, revision_id=None, force_new_repo=False):
         """Clone this bzrdir and its contents to url verbatim.
@@ -498,7 +523,36 @@
         :param transport: Transport containing the bzrdir.
         :param _unsupported: private.
         """
-        format = BzrDirFormat.find_format(transport)
+        base = transport.base
+
+        def find_format(transport):
+            return transport, BzrDirFormat.find_format(transport)
+
+        def redirected(transport, e, redirection_notice):
+            qualified_source = e.get_source_url()
+            relpath = transport.relpath(qualified_source)
+            if not e.target.endswith(relpath):
+                # Not redirected to a branch-format, not a branch
+                raise errors.NotBranchError(path=e.target)
+            target = e.target[:-len(relpath)]
+            note('%s is%s redirected to %s',
+                 transport.base, e.permanently, target)
+            # Let's try with a new transport
+            qualified_target = e.get_target_url()[:-len(relpath)]
+            # FIXME: If 'transport' has a qualifier, this should
+            # be applied again to the new transport *iff* the
+            # schemes used are the same. It's a bit tricky to
+            # verify, so I'll punt for now
+            # -- vila20070212
+            return get_transport(target)
+
+        try:
+            transport, format = do_catching_redirections(find_format,
+                                                         transport,
+                                                         redirected)
+        except errors.TooManyRedirections:
+            raise errors.NotBranchError(base)
+
         BzrDir._check_supported(format, _unsupported)
         return format.open(transport, _found=True)
 
@@ -613,7 +667,7 @@
         workingtree and discards it, and that's somewhat expensive.) 
         """
         try:
-            self.open_workingtree()
+            self.open_workingtree(recommend_upgrade=False)
             return True
         except errors.NoWorkingTree:
             return False
@@ -631,7 +685,10 @@
         except errors.NoRepositoryPresent:
             source_repository = None
         try:
-            tree = self.open_workingtree()
+            # TODO: Couldn't we just probe for the format in these cases,
+            # rather than opening the whole tree?  It would be a little
+            # faster. mbp 20070401
+            tree = self.open_workingtree(recommend_upgrade=False)
         except (errors.NoWorkingTree, errors.NotLocalUrl):
             result_format.workingtree_format = None
         else:
@@ -801,13 +858,15 @@
     def create_workingtree(self, revision_id=None):
         """See BzrDir.create_workingtree."""
         # this looks buggy but is not -really-
+        # because this format creates the workingtree when the bzrdir is
+        # created
         # clone and sprout will have set the revision_id
         # and that will have set it for us, its only
         # specific uses of create_workingtree in isolation
         # that can do wonky stuff here, and that only
         # happens for creating checkouts, which cannot be 
         # done on this format anyway. So - acceptable wart.
-        result = self.open_workingtree()
+        result = self.open_workingtree(recommend_upgrade=False)
         if revision_id is not None:
             if revision_id == _mod_revision.NULL_REVISION:
                 result.set_parent_ids([])
@@ -918,10 +977,14 @@
         from bzrlib.repofmt.weaverepo import RepositoryFormat5
         return RepositoryFormat5().open(self, _found=True)
 
-    def open_workingtree(self, _unsupported=False):
+    def open_workingtree(self, _unsupported=False,
+            recommend_upgrade=True):
         """See BzrDir.create_workingtree."""
         from bzrlib.workingtree import WorkingTreeFormat2
-        return WorkingTreeFormat2().open(self, _found=True)
+        wt_format = WorkingTreeFormat2()
+        # we don't warn here about upgrades; that ought to be handled for the
+        # bzrdir as a whole
+        return wt_format.open(self, _found=True)
 
 
 class BzrDir6(BzrDirPreSplitOut):
@@ -935,8 +998,11 @@
         from bzrlib.repofmt.weaverepo import RepositoryFormat6
         return RepositoryFormat6().open(self, _found=True)
 
-    def open_workingtree(self, _unsupported=False):
+    def open_workingtree(self, _unsupported=False,
+        recommend_upgrade=True):
         """See BzrDir.create_workingtree."""
+        # we don't warn here about upgrades; that ought to be handled for the
+        # bzrdir as a whole
         from bzrlib.workingtree import WorkingTreeFormat2
         return WorkingTreeFormat2().open(self, _found=True)
 
@@ -969,7 +1035,7 @@
 
     def destroy_workingtree(self):
         """See BzrDir.destroy_workingtree."""
-        wt = self.open_workingtree()
+        wt = self.open_workingtree(recommend_upgrade=False)
         repository = wt.branch.repository
         empty = repository.revision_tree(_mod_revision.NULL_REVISION)
         wt.revert([], old_tree=empty)
@@ -1049,7 +1115,8 @@
         except errors.NotBranchError:
             pass
         try:
-            if not isinstance(self.open_workingtree()._format,
+            my_wt = self.open_workingtree(recommend_upgrade=False)
+            if not isinstance(my_wt._format,
                               format.workingtree_format.__class__):
                 # the workingtree needs an upgrade.
                 return True
@@ -1071,11 +1138,14 @@
         self._check_supported(format, unsupported)
         return format.open(self, _found=True)
 
-    def open_workingtree(self, unsupported=False):
+    def open_workingtree(self, unsupported=False,
+            recommend_upgrade=True):
         """See BzrDir.open_workingtree."""
         from bzrlib.workingtree import WorkingTreeFormat
         format = WorkingTreeFormat.find_format(self)
-        self._check_supported(format, unsupported)
+        self._check_supported(format, unsupported,
+            recommend_upgrade,
+            basedir=self.root_transport.base)
         return format.open(self, _found=True)
 
 
@@ -1262,7 +1332,7 @@
 
     @classmethod
     def register_control_format(klass, format):
-        """Register a format that does not use '.bzrdir' for its control dir.
+        """Register a format that does not use '.bzr' for its control dir.
 
         TODO: This should be pulled up into a 'ControlDirFormat' base class
         which BzrDirFormat can inherit from, and renamed to register_format 
@@ -1294,10 +1364,6 @@
         klass._control_formats.remove(format)
 
 
-# register BzrDirFormat as a control format
-BzrDirFormat.register_control_format(BzrDirFormat)
-
-
 class BzrDirFormat4(BzrDirFormat):
     """Bzr dir format 4.
 
@@ -1554,6 +1620,10 @@
                                   __set_workingtree_format)
 
 
+# Register bzr control format
+BzrDirFormat.register_control_format(BzrDirFormat)
+
+# Register bzr formats
 BzrDirFormat.register_format(BzrDirFormat4())
 BzrDirFormat.register_format(BzrDirFormat5())
 BzrDirFormat.register_format(BzrDirFormat6())
@@ -2065,7 +2135,7 @@
                 branch_converter = _mod_branch.Converter5to6()
                 branch_converter.convert(branch)
         try:
-            tree = self.bzrdir.open_workingtree()
+            tree = self.bzrdir.open_workingtree(recommend_upgrade=False)
         except (errors.NoWorkingTree, errors.NotLocalUrl):
             pass
         else:

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2007-03-21 01:34:41 +0000
+++ bzrlib/commit.py	2007-04-01 06:19:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/config.py'
--- bzrlib/config.py	2007-01-30 12:04:20 +0000
+++ bzrlib/config.py	2007-03-22 07:04:04 +0000
@@ -1,5 +1,6 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005, 2007 Canonical Ltd
 #   Authors: Robert Collins <robert.collins@canonical.com>
+#            and others
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/dirstate.py'
--- bzrlib/dirstate.py	2007-03-21 04:14:35 +0000
+++ bzrlib/dirstate.py	2007-04-01 01:38:25 +0000
@@ -2167,16 +2167,32 @@
 
         This can be useful in debugging; it shouldn't be necessary in 
         normal code.
+
+        This must be called with a lock held.
         """
+        # NOTE: This must always raise AssertionError not just assert,
+        # otherwise it may not behave properly under python -O
+        #
+        # TODO: All entries must have some content that's not 'a' or 'r',
+        # otherwise it could just be removed.
+        #
+        # TODO: All relocations must point directly to a real entry.
+        #
+        # TODO: No repeated keys.
+        #
+        # -- mbp 20070325
         from pprint import pformat
+        self._read_dirblocks_if_needed()
         if len(self._dirblocks) > 0:
-            assert self._dirblocks[0][0] == '', \
+            if not self._dirblocks[0][0] == '':
+                raise AssertionError(
                     "dirblocks don't start with root block:\n" + \
-                    pformat(dirblocks)
+                    pformat(dirblocks))
         if len(self._dirblocks) > 1:
-            assert self._dirblocks[1][0] == '', \
+            if not self._dirblocks[1][0] == '':
+                raise AssertionError(
                     "dirblocks missing root directory:\n" + \
-                    pformat(dirblocks)
+                    pformat(dirblocks))
         # the dirblocks are sorted by their path components, name, and dir id
         dir_names = [d[0].split('/')
                 for d in self._dirblocks[1:]]
@@ -2189,9 +2205,72 @@
         for dirblock in self._dirblocks:
             # within each dirblock, the entries are sorted by filename and
             # then by id.
-            assert dirblock[1] == sorted(dirblock[1]), \
-                "dirblock for %r is not sorted:\n%s" % \
-                (dirblock[0], pformat(dirblock))
+            for entry in dirblock[1]:
+                if dirblock[0] != entry[0][0]:
+                    raise AssertionError(
+                        "entry key for %r"
+                        "doesn't match directory name in\n%r" %
+                        (entry, pformat(dirblock)))
+            if dirblock[1] != sorted(dirblock[1]):
+                raise AssertionError(
+                    "dirblock for %r is not sorted:\n%s" % \
+                    (dirblock[0], pformat(dirblock)))
+
+        # For each file id, for each tree: either
+        # the file id is not present at all; all rows with that id in the
+        # key have it marked as 'absent'
+        # OR the file id is present under exactly one name; any other entries 
+        # that mention that id point to the correct name.
+        #
+        # We check this with a dict per tree pointing either to the present
+        # name, or None if absent.
+        tree_count = self._num_present_parents() + 1
+        id_path_maps = [dict() for i in range(tree_count)]
+        # Make sure that all renamed entries point to the correct location.
+        for entry in self._iter_entries():
+            file_id = entry[0][2]
+            this_path = osutils.pathjoin(entry[0][0], entry[0][1])
+            if len(entry[1]) != tree_count:
+                raise AssertionError(
+                "wrong number of entry details for row\n%s" \
+                ",\nexpected %d" % \
+                (pformat(entry), tree_count))
+            for tree_index, tree_state in enumerate(entry[1]):
+                this_tree_map = id_path_maps[tree_index]
+                minikind = tree_state[0]
+                # have we seen this id before in this column?
+                if file_id in this_tree_map:
+                    previous_path = this_tree_map[file_id]
+                    # any later mention of this file must be consistent with
+                    # what was said before
+                    if minikind == 'a':
+                        if previous_path is not None:
+                            raise AssertionError(
+                            "file %s is absent in row %r but also present " \
+                            "at %r"% \
+                            (file_id, entry, previous_path))
+                    elif minikind == 'r':
+                        target_location = tree_state[1]
+                        if previous_path != target_location:
+                            raise AssertionError(
+                            "file %s relocation in row %r but also at %r" \
+                            % (file_id, entry, previous_path))
+                    else:
+                        # a file, directory, etc - may have been previously
+                        # pointed to by a relocation, which must point here
+                        if previous_path != this_path:
+                            raise AssertionError(
+                            "entry %r inconsistent with previous path %r" % \
+                            (entry, previous_path))
+                else:
+                    if minikind == 'a':
+                        # absent; should not occur anywhere else
+                        this_tree_map[file_id] = None
+                    elif minikind == 'r':
+                        # relocation, must occur at expected location 
+                        this_tree_map[file_id] = tree_state[1]
+                    else:
+                        this_tree_map[file_id] = this_path
 
     def _wipe_state(self):
         """Forget all state information about the dirstate."""
@@ -2292,6 +2371,6 @@
     # well within the noise margin
 
     # base64.encode always adds a final newline, so strip it off
-    return _encode(_pack('>llllll'
+    return _encode(_pack('>LLLLLL'
         , st.st_size, int(st.st_mtime), int(st.st_ctime)
-        , st.st_dev, st.st_ino, st.st_mode))[:-1]
+        , st.st_dev, st.st_ino & 0xFFFFFFFF, st.st_mode))[:-1]

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2007-03-29 16:23:49 +0000
+++ bzrlib/errors.py	2007-04-01 06:19:16 +0000
@@ -550,6 +550,15 @@
         self.bzrdir = bzrdir_format
 
 
+class IncompatibleRepositories(BzrError):
+
+    _fmt = "Repository %(target)s is not compatible with repository"\
+        " %(source)s"
+
+    def __init__(self, source, target):
+        BzrError.__init__(self, target=target, source=source)
+
+
 class IncompatibleRevision(BzrError):
     
     _fmt = "Revision is not compatible with %(repo_format)s"
@@ -1285,6 +1294,59 @@
         InvalidHttpResponse.__init__(self, path, msg)
 
 
+class RedirectRequested(TransportError):
+
+    _fmt = '%(source)s is%(permanently)s redirected to %(target)s'
+
+    def __init__(self, source, target, is_permament=False, qual_proto=None):
+        self.source = source
+        self.target = target
+        if is_permament:
+            self.permanently = ' permanently'
+        else:
+            self.permanently = ''
+        self.is_permament = is_permament
+        self._qualified_proto = qual_proto
+        TransportError.__init__(self)
+
+    def _requalify_url(self, url):
+        """Restore the qualified proto in front of the url"""
+        # When this exception is raised, source and target are in
+        # user readable format. But some transports may use a
+        # different proto (http+urllib:// will present http:// to
+        # the user. If a qualified proto is specified, the code
+        # trapping the exception can get the qualified urls to
+        # properly handle the redirection themself (creating a
+        # new transport object from the target url for example).
+        # But checking that the scheme of the original and
+        # redirected urls are the same can be tricky. (see the
+        # FIXME in BzrDir.open_from_transport for the unique use
+        # case so far).
+        if self._qualified_proto is None:
+            return url
+
+        # The TODO related to NotBranchError mention that doing
+        # that kind of manipulation on the urls may not be the
+        # exception object job. On the other hand, this object is
+        # the interface between the code and the user so
+        # presenting the urls in different ways is indeed its
+        # job...
+        import urlparse
+        proto, netloc, path, query, fragment = urlparse.urlsplit(url)
+        return urlparse.urlunsplit((self._qualified_proto, netloc, path,
+                                   query, fragment))
+
+    def get_source_url(self):
+        return self._requalify_url(self.source)
+
+    def get_target_url(self):
+        return self._requalify_url(self.target)
+
+
+class TooManyRedirections(TransportError):
+
+    _fmt = "Too many redirections"
+
 class ConflictsInTree(BzrError):
 
     _fmt = "Working tree has conflicts."

=== modified file 'bzrlib/help_topics.py'
--- bzrlib/help_topics.py	2007-03-26 09:59:49 +0000
+++ bzrlib/help_topics.py	2007-04-01 15:52:43 +0000
@@ -199,12 +199,12 @@
 then there wont be a noticeable difference.
 
 Another possible use for a checkout is to use it with a treeless repository
-containing your branches, where you maintain only only one working tree by
+containing your branches, where you maintain only one working tree by
 switching the master branch that the checkout points to when you want to 
 work on a different branch.
 
 Obviously to commit on a checkout you need to be able to write to the master
-branch. This means that the master branch must be accessable over a writeable
+branch. This means that the master branch must be accessible over a writeable
 protocol , such as sftp://, and that you have write permissions at the other
 end. Checkouts also work on the local file system, so that all that matters is
 file permissions.

=== added file 'bzrlib/hooks.py'
--- bzrlib/hooks.py	1970-01-01 00:00:00 +0000
+++ bzrlib/hooks.py	2007-03-25 08:59:56 +0000
@@ -0,0 +1,46 @@
+# Copyright (C) 2007 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""Support for plugin hooking logic."""
+from bzrlib.lazy_import import lazy_import
+lazy_import(globals(), """
+from bzrlib import (
+        errors,
+        )
+""")
+
+
+class Hooks(dict):
+    """A dictionary mapping hook name to a list of callables.
+    
+    e.g. ['FOO'] Is the list of items to be called when the
+    FOO hook is triggered.
+    """
+
+    def install_hook(self, hook_name, a_callable):
+        """Install a_callable in to the hook hook_name.
+
+        :param hook_name: A hook name. See the __init__ method of BranchHooks
+            for the complete list of hooks.
+        :param a_callable: The callable to be invoked when the hook triggers.
+            The exact signature will depend on the hook - see the __init__ 
+            method of BranchHooks for details on each hook.
+        """
+        try:
+            self[hook_name].append(a_callable)
+        except KeyError:
+            raise errors.UnknownHook(self.__class__.__name__, hook_name)

=== modified file 'bzrlib/info.py'
--- bzrlib/info.py	2007-02-03 10:56:04 +0000
+++ bzrlib/info.py	2007-04-04 11:40:26 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 # 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -256,7 +256,7 @@
     """Show statistics about a repository."""
     if 'revisions' in stats or 'size' in stats:
         print
-        print 'Revision store:'
+        print 'Repository:'
     if 'revisions' in stats:
         revisions = stats['revisions']
         print '  %8d revision%s' % (revisions, plural(revisions))
@@ -273,7 +273,8 @@
 def show_bzrdir_info(a_bzrdir, verbose=False):
     """Output to stdout the 'info' for a_bzrdir."""
     try:
-        working = a_bzrdir.open_workingtree()
+        working = a_bzrdir.open_workingtree(
+            recommend_upgrade=False)
         working.lock_read()
         try:
             show_tree_info(working, verbose)

=== modified file 'bzrlib/inventory.py'
--- bzrlib/inventory.py	2007-03-07 01:14:11 +0000
+++ bzrlib/inventory.py	2007-04-04 02:31:25 +0000
@@ -193,6 +193,9 @@
             if self.file_id in inv:
                 ie = inv[self.file_id]
                 assert ie.file_id == self.file_id
+                if ie.kind != self.kind:
+                    # Can't be a candidate if the kind has changed.
+                    continue
                 if ie.revision in candidates:
                     # same revision value in two different inventories:
                     # correct possible inconsistencies:
@@ -491,6 +494,8 @@
         # renamed
         elif previous_ie.name != self.name:
             compatible = False
+        elif previous_ie.kind != self.kind:
+            compatible = False
         return compatible
 
     def _read_tree_state(self, path, work_tree):
@@ -1149,7 +1154,7 @@
             if entry.name in parent.children:
                 raise BzrError("%s is already versioned" %
                         osutils.pathjoin(self.id2path(parent.file_id),
-                        entry.name))
+                        entry.name).encode('utf-8'))
             parent.children[entry.name] = entry
         return self._add_child(entry)
 
@@ -1326,6 +1331,8 @@
             del self._byid[file_id]
         if ie.parent_id is not None:
             del self[ie.parent_id].children[ie.name]
+        else:
+            self.root = None
 
     def rename(self, file_id, new_parent_id, new_name):
         """Move a file within the inventory.

=== modified file 'bzrlib/merge_directive.py'
--- bzrlib/merge_directive.py	2007-03-23 03:37:01 +0000
+++ bzrlib/merge_directive.py	2007-04-01 04:06:14 +0000
@@ -28,7 +28,9 @@
     testament,
     timestamp,
     )
-from bzrlib.bundle import serializer as bundle_serializer
+from bzrlib.bundle import (
+    serializer as bundle_serializer,
+    )
 
 
 class MergeDirective(object):
@@ -250,3 +252,16 @@
         bundle_serializer.write_bundle(repository, revision_id,
                                        ancestor_id, s)
         return s.getvalue()
+
+    def install_revisions(self, target_repo):
+        """Install revisions and return the target revision"""
+        if not target_repo.has_revision(self.revision_id):
+            if self.patch_type == 'bundle':
+                info = bundle_serializer.read_bundle(StringIO(self.patch))
+                # We don't use the bundle's target revision, because
+                # MergeDirective.revision_id is authoritative.
+                info.install_revisions(target_repo)
+            else:
+                source_branch = _mod_branch.Branch.open(self.source_branch)
+                target_repo.fetch(source_branch.repository, self.revision_id)
+        return self.revision_id

=== modified file 'bzrlib/mutabletree.py'
--- bzrlib/mutabletree.py	2007-03-27 05:53:02 +0000
+++ bzrlib/mutabletree.py	2007-04-02 17:55:02 +0000
@@ -143,6 +143,43 @@
         """
         raise NotImplementedError(self._add)
 
+    @needs_tree_write_lock
+    def apply_inventory_delta(self, changes):
+        """Apply changes to the inventory as an atomic operation.
+
+        The argument is a set of changes to apply.  It must describe a
+        valid result, but the order is not important.  Specifically,
+        intermediate stages *may* be invalid, such as when two files
+        swap names.
+
+        The changes should be structured as a list of tuples, of the form
+        (old_path, new_path, file_id, new_entry).  For creation, old_path
+        must be None.  For deletion, new_path and new_entry must be None.
+        file_id is always non-None.  For renames and other mutations, all
+        values must be non-None.
+
+        If the new_entry is a directory, its children should be an empty
+        dict.  Children are handled by apply_inventory_delta itself.
+
+        :param changes: A list of tuples for the change to apply:
+            [(old_path, new_path, file_id, new_inventory_entry), ...]
+        """
+        self.flush()
+        inv = self.inventory
+        children = {}
+        for old_path, file_id in sorted(((op, f) for op, np, f, e in changes
+                                        if op is not None), reverse=True):
+            if file_id not in inv:
+                continue
+            children[file_id] = getattr(inv[file_id], 'children', {})
+            inv.remove_recursive_id(file_id)
+        for new_path, new_entry in sorted((np, e) for op, np, f, e in
+                                          changes if np is not None):
+            if getattr(new_entry, 'children', None) is not None:
+                new_entry.children = children.get(new_entry.file_id, {})
+            inv.add(new_entry)
+        self._write_inventory(inv)
+
     @needs_write_lock
     def commit(self, message=None, revprops=None, *args,
                **kwargs):

=== modified file 'bzrlib/repofmt/knitrepo.py'
--- bzrlib/repofmt/knitrepo.py	2007-03-29 01:36:44 +0000
+++ bzrlib/repofmt/knitrepo.py	2007-04-01 06:19:16 +0000
@@ -407,7 +407,7 @@
 
     repository_class = KnitRepository3
     rich_root_data = True
-    support_tree_reference = True
+    supports_tree_reference = True
 
     def _get_matching_bzrdir(self):
         return bzrdir.format_registry.make_bzrdir('dirstate-with-subtree')
@@ -421,7 +421,7 @@
         if not target_format.rich_root_data:
             raise errors.BadConversionTarget(
                 'Does not support rich root data.', target_format)
-        if not getattr(target_format, 'support_tree_reference', False):
+        if not getattr(target_format, 'supports_tree_reference', False):
             raise errors.BadConversionTarget(
                 'Does not support nested trees', target_format)
             

=== modified file 'bzrlib/repofmt/weaverepo.py'
--- bzrlib/repofmt/weaverepo.py	2007-03-29 01:36:44 +0000
+++ bzrlib/repofmt/weaverepo.py	2007-04-01 06:19:16 +0000
@@ -119,7 +119,7 @@
     """Base class for the pre split out repository formats."""
 
     rich_root_data = False
-    support_tree_reference = False
+    supports_tree_reference = False
 
     def initialize(self, a_bzrdir, shared=False, _internal=False):
         """Create a weave repository.

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2007-03-30 02:36:36 +0000
+++ bzrlib/repository.py	2007-04-01 06:19:16 +0000
@@ -326,8 +326,11 @@
         If revision_id is None all content is copied.
         """
         revision_id = osutils.safe_revision_id(revision_id)
-        return InterRepository.get(source, self).fetch(revision_id=revision_id,
-                                                       pb=pb)
+        inter = InterRepository.get(source, self)
+        try:
+            return inter.fetch(revision_id=revision_id, pb=pb)
+        except NotImplementedError:
+            raise errors.IncompatibleRepositories(source, self)
 
     def get_commit_builder(self, branch, parents, config, timestamp=None, 
                            timezone=None, committer=None, revprops=None, 
@@ -1204,7 +1207,7 @@
     """Common base class for the new repositories using the metadir layout."""
 
     rich_root_data = False
-    support_tree_reference = False
+    supports_tree_reference = False
     _matchingbzrdir = bzrdir.BzrDirMetaFormat1()
 
     def __init__(self):

=== modified file 'bzrlib/strace.py'
--- bzrlib/strace.py	2007-03-27 07:37:12 +0000
+++ bzrlib/strace.py	2007-04-04 21:39:03 +0000
@@ -17,6 +17,7 @@
 
 """Support for running strace against the current process."""
 
+import errno
 import os
 import signal
 import subprocess
@@ -33,17 +34,18 @@
     :return: a tuple: function-result, a StraceResult.
     """
     # capture strace output to a file
-    log_file = tempfile.TemporaryFile()
+    log_file = tempfile.NamedTemporaryFile()
     log_file_fd = log_file.fileno()
     pid = os.getpid()
     # start strace
     proc = subprocess.Popen(['strace',
-        '-f', '-r', '-tt', '-p', str(pid),
+        '-f', '-r', '-tt', '-p', str(pid), '-o', log_file.name
         ],
-        stderr=log_file_fd,
-        stdout=log_file_fd)
-    # TODO? confirm its started (test suite should be sufficient)
-    # (can loop on proc.pid, but that may not indicate started and attached.)
+        stdout=subprocess.PIPE,
+        stderr=subprocess.STDOUT)
+    # Wait for strace to attach
+    attached_notice = proc.stdout.readline()
+    # Run the function to strace
     result = function(*args, **kwargs)
     # stop strace
     os.kill(proc.pid, signal.SIGQUIT)

=== modified file 'bzrlib/tests/HTTPTestUtil.py'
--- bzrlib/tests/HTTPTestUtil.py	2006-12-22 09:54:52 +0000
+++ bzrlib/tests/HTTPTestUtil.py	2007-03-14 16:39:24 +0000
@@ -17,6 +17,7 @@
 from cStringIO import StringIO
 import errno
 from SimpleHTTPServer import SimpleHTTPRequestHandler
+import re
 import socket
 import urlparse
 
@@ -120,7 +121,7 @@
         """Hand the request off to a smart server instance."""
         self.send_response(200)
         self.send_header("Content-type", "application/octet-stream")
-        transport = get_transport(self.server.test_case._home_dir)
+        transport = get_transport(self.server.test_case_server._home_dir)
         # TODO: We might like to support streaming responses.  1.0 allows no
         # Content-length in this case, so for integrity we should perform our
         # own chunking within the stream.
@@ -177,9 +178,9 @@
 
 
 class TestCaseWithTwoWebservers(TestCaseWithWebserver):
-    """A support class providinf readonly urls (on two servers) that are http://.
+    """A support class providing readonly urls on two servers that are http://.
 
-    We setup two webservers to allows various tests involving
+    We set up two webservers to allows various tests involving
     proxies or redirections from one server to the other.
     """
     def setUp(self):
@@ -225,4 +226,86 @@
         return TestingHTTPRequestHandler.translate_path(self, path)
 
 
+class RedirectRequestHandler(TestingHTTPRequestHandler):
+    """Redirect all request to the specified server"""
+
+    def parse_request(self):
+        """Redirect a single HTTP request to another host"""
+        valid = TestingHTTPRequestHandler.parse_request(self)
+        if valid:
+            tcs = self.server.test_case_server
+            code, target = tcs.is_redirected(self.path)
+            if code is not None and target is not None:
+                # Redirect as instructed
+                self.send_response(code)
+                self.send_header('Location', target)
+                self.end_headers()
+                return False # The job is done
+            else:
+                # We leave the parent class serve the request
+                pass
+        return valid
+
+
+class HTTPServerRedirecting(HttpServer):
+    """An HttpServer redirecting to another server """
+
+    def __init__(self, request_handler=RedirectRequestHandler):
+        HttpServer.__init__(self, request_handler)
+        # redirections is a list of tuples (source, target, code)
+        # - source is a regexp for the paths requested
+        # - target is a replacement for re.sub describing where
+        #   the request will be redirected
+        # - code is the http error code associated to the
+        #   redirection (301 permanent, 302 temporarry, etc
+        self.redirections = []
+
+    def redirect_to(self, host, port):
+        """Redirect all requests to a specific host:port"""
+        self.redirections = [('(.*)',
+                              r'http://%s:%s\1' % (host, port) ,
+                              301)]
+
+    def is_redirected(self, path):
+        """Is the path redirected by this server.
+
+        :param path: the requested relative path
+
+        :returns: a tuple (code, target) if a matching
+             redirection is found, (None, None) otherwise.
+        """
+        code = None
+        target = None
+        for (rsource, rtarget, rcode) in self.redirections:
+            target, match = re.subn(rsource, rtarget, path)
+            if match:
+                code = rcode
+                break # The first match wins
+            else:
+                target = None
+        return code, target
+
+
+class TestCaseWithRedirectedWebserver(TestCaseWithTwoWebservers):
+   """A support class providing redirections from one server to another.
+
+   We set up two webservers to allows various tests involving
+   redirections.
+   The 'old' server is redirected to the 'new' server.
+   """
+
+   def create_transport_secondary_server(self):
+       """Create the secondary server redirecting to the primary server"""
+       new = self.get_readonly_server()
+       redirecting = HTTPServerRedirecting()
+       redirecting.redirect_to(new.host, new.port)
+       return redirecting
+
+   def setUp(self):
+       super(TestCaseWithRedirectedWebserver, self).setUp()
+       # The redirections will point to the new server
+       self.new_server = self.get_readonly_server()
+       # The requests to the old server will be redirected
+       self.old_server = self.get_secondary_server()
+
 

=== modified file 'bzrlib/tests/HttpServer.py'
--- bzrlib/tests/HttpServer.py	2007-03-28 13:33:58 +0000
+++ bzrlib/tests/HttpServer.py	2007-04-01 06:19:16 +0000
@@ -44,12 +44,13 @@
 class TestingHTTPRequestHandler(SimpleHTTPRequestHandler):
 
     def log_message(self, format, *args):
-        self.server.test_case.log('webserver - %s - - [%s] %s "%s" "%s"',
-                                  self.address_string(),
-                                  self.log_date_time_string(),
-                                  format % args,
-                                  self.headers.get('referer', '-'),
-                                  self.headers.get('user-agent', '-'))
+        tcs = self.server.test_case_server
+        tcs.log('webserver - %s - - [%s] %s "%s" "%s"',
+                self.address_string(),
+                self.log_date_time_string(),
+                format % args,
+                self.headers.get('referer', '-'),
+                self.headers.get('user-agent', '-'))
 
     def handle_one_request(self):
         """Handle a single HTTP request.
@@ -154,7 +155,6 @@
             self.end_headers()
             self.send_range_content(file, start, end - start + 1)
             self.wfile.write("--%s\r\n" % boundary)
-            pass
 
     def do_GET(self):
         """Serve a GET request.
@@ -249,10 +249,16 @@
 
 
 class TestingHTTPServer(BaseHTTPServer.HTTPServer):
-    def __init__(self, server_address, RequestHandlerClass, test_case):
+
+    def __init__(self, server_address, RequestHandlerClass,
+                 test_case_server):
         BaseHTTPServer.HTTPServer.__init__(self, server_address,
-                                                RequestHandlerClass)
-        self.test_case = test_case
+                                           RequestHandlerClass)
+        # test_case_server can be used to communicate between the
+        # tests and the server (or the request handler and the
+        # server), allowing dynamic behaviors to be defined from
+        # the tests cases.
+        self.test_case_server = test_case_server
 
 
 class HttpServer(Server):
@@ -268,18 +274,23 @@
     def __init__(self, request_handler=TestingHTTPRequestHandler):
         Server.__init__(self)
         self.request_handler = request_handler
+        self.host = 'localhost'
+        self.port = 0
+        self._httpd = None
 
     def _get_httpd(self):
-        return TestingHTTPServer(('localhost', 0),
-                                  self.request_handler,
-                                  self)
+        if self._httpd is None:
+            self._httpd = TestingHTTPServer((self.host, self.port),
+                                            self.request_handler,
+                                            self)
+            host, self.port = self._httpd.socket.getsockname()
+        return self._httpd
 
     def _http_start(self):
-        httpd = None
         httpd = self._get_httpd()
-        host, self.port = httpd.socket.getsockname()
-        self._http_base_url = '%s://localhost:%s/' % (self._url_protocol,
-                                                      self.port)
+        self._http_base_url = '%s://%s:%s/' % (self._url_protocol,
+                                               self.host,
+                                               self.port)
         self._http_starting.release()
         httpd.socket.settimeout(0.1)
 

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2007-03-28 22:31:41 +0000
+++ bzrlib/tests/__init__.py	2007-04-04 05:19:38 +0000
@@ -755,7 +755,10 @@
         self._benchcalls = []
         self._benchtime = None
         # prevent hooks affecting tests
-        self._preserved_hooks = bzrlib.branch.Branch.hooks
+        self._preserved_hooks = {
+            bzrlib.branch.Branch:bzrlib.branch.Branch.hooks,
+            bzrlib.transport.smart.SmartTCPServer:bzrlib.transport.smart.SmartTCPServer.hooks,
+            }
         self.addCleanup(self._restoreHooks)
         # this list of hooks must be kept in sync with the defaults
         # in branch.py
@@ -868,6 +871,26 @@
                 excName = str(excClass)
             raise self.failureException, "%s not raised" % excName
 
+    def assertRaises(self, excClass, func, *args, **kwargs):
+        """Assert that a callable raises a particular exception.
+
+        :param excClass: As for the except statement, this may be either an
+        exception class, or a tuple of classes.
+
+        Returns the exception so that you can examine it.
+        """
+        try:
+            func(*args, **kwargs)
+        except excClass, e:
+            return e
+        else:
+            if getattr(excClass,'__name__', None) is not None:
+                excName = excClass.__name__
+            else:
+                # probably a tuple
+                excName = str(excClass)
+            raise self.failureException, "%s not raised" % excName
+
     def assertIs(self, left, right, message=None):
         if not (left is right):
             if message is not None:
@@ -900,6 +923,41 @@
             self.fail("%r is an instance of %s rather than %s" % (
                 obj, obj.__class__, kls))
 
+    def expectFailure(self, reason, assertion, *args, **kwargs):
+        """Invoke a test, expecting it to fail for the given reason.
+
+        This is for assertions that ought to succeed, but currently fail.
+        (The failure is *expected* but not *wanted*.)  Please be very precise
+        about the failure you're expecting.  If a new bug is introduced,
+        AssertionError should be raised, not KnownFailure.
+
+        Frequently, expectFailure should be followed by an opposite assertion.
+        See example below.
+
+        Intended to be used with a callable that raises AssertionError as the
+        'assertion' parameter.  args and kwargs are passed to the 'assertion'.
+
+        Raises KnownFailure if the test fails.  Raises AssertionError if the
+        test succeeds.
+
+        example usage::
+
+          self.expectFailure('Math is broken', self.assertNotEqual, 54,
+                             dynamic_val)
+          self.assertEqual(42, dynamic_val)
+
+          This means that a dynamic_val of 54 will cause the test to raise
+          a KnownFailure.  Once math is fixed and the expectFailure is removed,
+          only a dynamic_val of 42 will allow the test to pass.  Anything other
+          than 54 or 42 will cause an AssertionError.
+        """
+        try:
+            assertion(*args, **kwargs)
+        except AssertionError:
+            raise KnownFailure(reason)
+        else:
+            self.fail('Unexpected success.  Should have failed: %s' % reason)
+
     def _capture_warnings(self, a_callable, *args, **kwargs):
         """A helper for callDeprecated and applyDeprecated.
 
@@ -1043,7 +1101,8 @@
             osutils.set_or_unset_env(name, value)
 
     def _restoreHooks(self):
-        bzrlib.branch.Branch.hooks = self._preserved_hooks
+        for klass, hooks in self._preserved_hooks.items():
+            setattr(klass, 'hooks', hooks)
 
     def knownFailure(self, reason):
         """This test has failed for some known reason."""

=== modified file 'bzrlib/tests/blackbox/test_bound_branches.py'
--- bzrlib/tests/blackbox/test_bound_branches.py	2007-03-14 03:42:40 +0000
+++ bzrlib/tests/blackbox/test_bound_branches.py	2007-03-22 23:56:58 +0000
@@ -128,7 +128,7 @@
         self.assertContainsRe(error, 'old locations')
 
     def init_meta_branch(self, path):
-        format = bzrdir.format_registry.make_bzrdir('knit')
+        format = bzrdir.format_registry.make_bzrdir('default')
         return BzrDir.create_branch_convenience(path, format=format)
 
     def test_bound_commit(self):

=== modified file 'bzrlib/tests/blackbox/test_info.py'
--- bzrlib/tests/blackbox/test_info.py	2007-03-06 02:04:08 +0000
+++ bzrlib/tests/blackbox/test_info.py	2007-04-04 11:40:26 +0000
@@ -72,7 +72,7 @@
 Branch history:
          0 revisions
 
-Revision store:
+Repository:
          0 revisions
          0 KiB
 """ % branch1.bzrdir.root_transport.base, out)
@@ -116,7 +116,7 @@
    first revision: %s
   latest revision: %s
 
-Revision store:
+Repository:
          1 revision
          %d KiB
 """ % (branch2.bzrdir.root_transport.base,
@@ -169,7 +169,7 @@
    first revision: %s
   latest revision: %s
 
-Revision store:
+Repository:
          1 revision
          %d KiB
 """ % (branch3.bzrdir.root_transport.base,
@@ -220,7 +220,7 @@
    first revision: %s
   latest revision: %s
 
-Revision store:
+Repository:
          1 revision
          %d KiB
 """ % (branch4.bzrdir.root_transport.base,
@@ -265,7 +265,7 @@
    first revision: %s
   latest revision: %s
 
-Revision store:
+Repository:
          1 revision
          0 KiB
 """ % (tree5.bzrdir.root_transport.base,
@@ -313,7 +313,7 @@
    first revision: %s
   latest revision: %s
 
-Revision store:
+Repository:
          1 revision
          0 KiB
 """ % (branch2.bzrdir.root_transport.base,
@@ -357,7 +357,7 @@
    first revision: %s
   latest revision: %s
 
-Revision store:
+Repository:
          1 revision
          %d KiB
 """ % (branch3.bzrdir.root_transport.base,
@@ -403,7 +403,7 @@
    first revision: %s
   latest revision: %s
 
-Revision store:
+Repository:
          1 revision
          %d KiB
 """ % (branch4.bzrdir.root_transport.base,
@@ -449,7 +449,7 @@
    first revision: %s
   latest revision: %s
 
-Revision store:
+Repository:
          2 revisions
          0 KiB
 """ % (tree5.bzrdir.root_transport.base,
@@ -476,7 +476,7 @@
 Branch history:
          0 revisions
 
-Revision store:
+Repository:
          0 revisions
          0 KiB
 """ % (branch.bzrdir.root_transport.base,
@@ -501,7 +501,7 @@
        control: Meta directory format 1
     repository: %s
 
-Revision store:
+Repository:
          0 revisions
          0 KiB
 """ % (repo.bzrdir.root_transport.base,
@@ -527,7 +527,7 @@
 Branch history:
          0 revisions
 
-Revision store:
+Repository:
          0 revisions
          0 KiB
 """ % (repo.bzrdir.root_transport.base,
@@ -586,7 +586,7 @@
    first revision: %s
   latest revision: %s
 
-Revision store:
+Repository:
          1 revision
          %d KiB
 """ % (tree2.bzrdir.root_transport.base,
@@ -628,7 +628,7 @@
 Branch history:
          0 revisions
 
-Revision store:
+Repository:
          0 revisions
          0 KiB
 """ % (tree3.bzrdir.root_transport.base,
@@ -671,7 +671,7 @@
    first revision: %s
   latest revision: %s
 
-Revision store:
+Repository:
          1 revision
          %d KiB
 """ % (tree3.bzrdir.root_transport.base, branch1.bzrdir.root_transport.base,
@@ -720,7 +720,7 @@
    first revision: %s
   latest revision: %s
 
-Revision store:
+Repository:
          2 revisions
          %d KiB
 """ % (tree2.bzrdir.root_transport.base,
@@ -753,7 +753,7 @@
    first revision: %s
   latest revision: %s
 
-Revision store:
+Repository:
          2 revisions
          %d KiB
 """ % (repo.bzrdir.root_transport.base,
@@ -776,7 +776,7 @@
        control: Meta directory format 1
     repository: %s
 
-Revision store:
+Repository:
          2 revisions
          %d KiB
 """ % (repo.bzrdir.root_transport.base,
@@ -805,7 +805,7 @@
 
 Create working tree for new branches inside the repository.
 
-Revision store:
+Repository:
          0 revisions
          0 KiB
 """ % (repo.bzrdir.root_transport.base,
@@ -846,7 +846,7 @@
          0 revisions
          0 committers
 
-Revision store:
+Repository:
          0 revisions
          0 KiB
 """ % (repo.bzrdir.root_transport.base,
@@ -890,7 +890,7 @@
    first revision: %s
   latest revision: %s
 
-Revision store:
+Repository:
          1 revision
          %d KiB
 """ % (repo.bzrdir.root_transport.base,
@@ -933,7 +933,7 @@
          0 revisions
          0 committers
 
-Revision store:
+Repository:
          1 revision
          %d KiB
 """ % (repo.bzrdir.root_transport.base,
@@ -980,7 +980,7 @@
    first revision: %s
   latest revision: %s
 
-Revision store:
+Repository:
          1 revision
          %d KiB
 """ % (repo.bzrdir.root_transport.base,
@@ -1006,7 +1006,7 @@
 
 Create working tree for new branches inside the repository.
 
-Revision store:
+Repository:
          1 revision
          %d KiB
 """ % (repo.bzrdir.root_transport.base,
@@ -1036,7 +1036,7 @@
 
 Create working tree for new branches inside the repository.
 
-Revision store:
+Repository:
          0 revisions
          0 KiB
 """ % (repo.bzrdir.root_transport.base,
@@ -1073,7 +1073,7 @@
 Branch history:
          0 revisions
 
-Revision store:
+Repository:
          0 revisions
          0 KiB
 """ % (repo.bzrdir.root_transport.base,
@@ -1173,7 +1173,7 @@
 Branch history:
          0 revisions
 %s
-Revision store:
+Repository:
          0 revisions
          0 KiB
 """ %  (tree_data,
@@ -1323,7 +1323,7 @@
 Branch history:
          0 revisions
 
-Revision store:
+Repository:
          0 revisions
          0 KiB
 """ % (tree.bzrdir.root_transport.base,
@@ -1356,7 +1356,7 @@
 Branch history:
          0 revisions
 
-Revision store:
+Repository:
          0 revisions
          0 KiB
 """ % (tree.bzrdir.root_transport.base,

=== modified file 'bzrlib/tests/blackbox/test_merge_directive.py'
--- bzrlib/tests/blackbox/test_merge_directive.py	2007-03-14 14:54:34 +0000
+++ bzrlib/tests/blackbox/test_merge_directive.py	2007-04-01 03:58:12 +0000
@@ -17,7 +17,11 @@
 import os
 import smtplib
 
-from bzrlib import gpg, tests
+from bzrlib import (
+    gpg,
+    tests,
+    workingtree,
+    )
 
 
 EMAIL1 = """To: pqm@example.com
@@ -25,7 +29,7 @@
 Subject: bar
 
 # Bazaar merge directive format 1
-# revision_id: jrandom@example.com-.*
+# revision_id: bar-id
 # target_branch: ../tree2
 # testament_sha1: .*
 # timestamp: .*
@@ -36,17 +40,17 @@
 class TestMergeDirective(tests.TestCaseWithTransport):
 
     def prepare_merge_directive(self):
-        tree1 = self.make_branch_and_tree('tree1')
+        self.tree1 = self.make_branch_and_tree('tree1')
         self.build_tree_contents([('tree1/file', 'a\nb\nc\nd\n')])
-        tree1.branch.get_config().set_user_option('email',
+        self.tree1.branch.get_config().set_user_option('email',
             'J. Random Hacker <jrandom@example.com>')
-        tree1.add('file')
-        tree1.commit('foo')
-        tree2=tree1.bzrdir.sprout('tree2').open_workingtree()
+        self.tree1.add('file')
+        self.tree1.commit('foo')
+        self.tree2 = self.tree1.bzrdir.sprout('tree2').open_workingtree()
         self.build_tree_contents([('tree1/file', 'a\nb\nc\nd\ne\n')])
-        tree1.commit('bar')
+        self.tree1.commit('bar', rev_id='bar-id')
         os.chdir('tree1')
-        return tree1, tree2
+        return self.tree1, self.tree2
 
     def test_merge_directive(self):
         self.prepare_merge_directive()
@@ -132,6 +136,74 @@
                           'pqm@example.com'), call[1:3])
         self.assertContainsRe(call[3], EMAIL1)
 
+    def test_pull_raw(self):
+        self.prepare_merge_directive()
+        self.tree1.commit('baz', rev_id='baz-id')
+        md_text = self.run_bzr('merge-directive', self.tree2.basedir,
+                               '-r', '2', self.tree1.basedir, '--plain')[0]
+        self.build_tree_contents([('../directive', md_text)])
+        os.chdir('../tree2')
+        self.run_bzr('pull', '../directive')
+        wt = workingtree.WorkingTree.open('.')
+        self.assertEqual('bar-id', wt.last_revision())
+
+    def test_pull_user_r(self):
+        """If the user supplies -r, an error is emitted"""
+        self.prepare_merge_directive()
+        self.tree1.commit('baz', rev_id='baz-id')
+        md_text = self.run_bzr('merge-directive', self.tree2.basedir,
+                               self.tree1.basedir, '--plain')[0]
+        self.build_tree_contents([('../directive', md_text)])
+        os.chdir('../tree2')
+        self.run_bzr_error(
+            ('Cannot use -r with merge directives or bundles',),
+            'pull', '-r', '2', '../directive')
+
+    def test_pull_bundle(self):
+        self.prepare_merge_directive()
+        self.tree1.commit('baz', rev_id='baz-id')
+        md_text = self.run_bzr('merge-directive', self.tree2.basedir,
+                               '-r', '2', '/dev/null', '--bundle')[0]
+        self.build_tree_contents([('../directive', md_text)])
+        os.chdir('../tree2')
+        self.run_bzr('pull', '../directive')
+        wt = workingtree.WorkingTree.open('.')
+        self.assertEqual('bar-id', wt.last_revision())
+
+    def test_merge_raw(self):
+        self.prepare_merge_directive()
+        self.tree1.commit('baz', rev_id='baz-id')
+        md_text = self.run_bzr('merge-directive', self.tree2.basedir,
+                               '-r', '2', self.tree1.basedir, '--plain')[0]
+        self.build_tree_contents([('../directive', md_text)])
+        os.chdir('../tree2')
+        self.run_bzr('merge', '../directive')
+        wt = workingtree.WorkingTree.open('.')
+        self.assertEqual('bar-id', wt.get_parent_ids()[1])
+
+    def test_merge_user_r(self):
+        """If the user supplies -r, an error is emitted"""
+        self.prepare_merge_directive()
+        self.tree1.commit('baz', rev_id='baz-id')
+        md_text = self.run_bzr('merge-directive', self.tree2.basedir,
+                               self.tree1.basedir, '--plain')[0]
+        self.build_tree_contents([('../directive', md_text)])
+        os.chdir('../tree2')
+        self.run_bzr_error(
+            ('Cannot use -r with merge directives or bundles',),
+            'merge', '-r', '2', '../directive')
+
+    def test_merge_bundle(self):
+        self.prepare_merge_directive()
+        self.tree1.commit('baz', rev_id='baz-id')
+        md_text = self.run_bzr('merge-directive', self.tree2.basedir,
+                               '-r', '2', '/dev/null', '--bundle')[0]
+        self.build_tree_contents([('../directive', md_text)])
+        os.chdir('../tree2')
+        self.run_bzr('merge', '../directive')
+        wt = workingtree.WorkingTree.open('.')
+        self.assertEqual('bar-id', wt.get_parent_ids()[1])
+
     def test_mail_uses_config(self):
         tree1, tree2 = self.prepare_merge_directive()
         tree1.branch.get_config().set_user_option('smtp_server', 'bogushost')

=== modified file 'bzrlib/tests/blackbox/test_upgrade.py'
--- bzrlib/tests/blackbox/test_upgrade.py	2007-03-08 22:08:08 +0000
+++ bzrlib/tests/blackbox/test_upgrade.py	2007-04-01 04:40:10 +0000
@@ -1,6 +1,6 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 # Authors: Robert Collins <robert.collins@canonical.com>
-# -*- coding: utf-8 -*-
+#          and others
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,14 +20,18 @@
 
 import os
 
-import bzrlib
-import bzrlib.bzrdir as bzrdir
-import bzrlib.repository as repository
-from bzrlib.tests import TestCaseWithTransport
-from bzrlib.tests import TestUIFactory
+from bzrlib import (
+    bzrdir,
+    repository,
+    ui,
+    )
+from bzrlib.tests import (
+    TestCaseInTempDir,
+    TestCaseWithTransport,
+    TestUIFactory,
+    )
 from bzrlib.tests.test_sftp_transport import TestCaseWithSFTPServer
 from bzrlib.transport import get_transport
-import bzrlib.ui as ui
 from bzrlib.repofmt.knitrepo import (
     RepositoryFormatKnit1,
     )
@@ -179,3 +183,21 @@
 finished
 """ % (url, url, url), out)
         self.assertEqual('', err)
+
+
+class UpgradeRecommendedTests(TestCaseInTempDir):
+
+    def test_recommend_upgrade_wt4(self):
+        # using a deprecated format gives a warning
+        self.run_bzr('init', '--knit', 'a')
+        out, err = self.run_bzr('status', 'a')
+        self.assertContainsRe(err, 'bzr upgrade .*[/\\\\]a')
+
+    def test_no_upgrade_recommendation_from_bzrdir(self):
+        # we should only get a recommendation to upgrade when we're accessing
+        # the actual workingtree, not when we only open a bzrdir that contains
+        # an old workngtree
+        self.run_bzr('init', '--knit', 'a')
+        out, err = self.run_bzr('checkout', 'a', 'b')
+        if err.find('upgrade') > -1:
+            self.fail("message shouldn't suggest upgrade:\n%s" % err)

=== modified file 'bzrlib/tests/repository_implementations/test_repository.py'
--- bzrlib/tests/repository_implementations/test_repository.py	2007-03-30 02:36:36 +0000
+++ bzrlib/tests/repository_implementations/test_repository.py	2007-04-01 06:19:16 +0000
@@ -429,7 +429,7 @@
         # template from the test suite parameterisation.
         repo = self.make_repository('.')
         repo._format.rich_root_data
-        repo._format.support_tree_reference
+        repo._format.supports_tree_reference
 
 
 class TestRepositoryLocking(TestCaseWithRepository):

=== modified file 'bzrlib/tests/test_branch.py'
--- bzrlib/tests/test_branch.py	2007-03-22 19:41:59 +0000
+++ bzrlib/tests/test_branch.py	2007-03-27 21:40:48 +0000
@@ -313,7 +313,7 @@
     def test_installed_hooks_are_BranchHooks(self):
         """The installed hooks object should be a BranchHooks."""
         # the installed hooks are saved in self._preserved_hooks.
-        self.assertIsInstance(self._preserved_hooks, BranchHooks)
+        self.assertIsInstance(self._preserved_hooks[_mod_branch.Branch], BranchHooks)
 
     def test_install_hook_raises_unknown_hook(self):
         """install_hook should raise UnknownHook if a hook is unknown."""

=== modified file 'bzrlib/tests/test_bundle.py'
--- bzrlib/tests/test_bundle.py	2007-03-06 06:35:00 +0000
+++ bzrlib/tests/test_bundle.py	2007-04-04 21:39:03 +0000
@@ -764,7 +764,7 @@
         bundle_file = StringIO()
         rev_ids = write_bundle(self.tree1.branch.repository, 'a@cset-0-3',
                                'a@cset-0-1', bundle_file, format=self.format)
-        self.assertNotContainsRe(bundle_file.getvalue(), 'two')
+        self.assertNotContainsRe(bundle_file.getvalue(), '\btwo\b')
         self.assertContainsRe(bundle_file.getvalue(), 'one')
         self.assertContainsRe(bundle_file.getvalue(), 'three')
 
@@ -784,10 +784,20 @@
             u'William Dod\xe9\n').encode('utf-8'))
         f.close()
 
-        self.tree1.add([u'with Dod\xe9'])
-        self.tree1.commit(u'i18n commit from William Dod\xe9', 
+        self.tree1.add([u'with Dod\xe9'], ['withdod-id'])
+        self.tree1.commit(u'i18n commit from William Dod\xe9',
                           rev_id='i18n-1', committer=u'William Dod\xe9')
 
+        if sys.platform == 'darwin':
+            # On Mac the '\xe9' gets changed to 'e\u0301'
+            self.assertEqual([u'.bzr', u'with Dode\u0301'],
+                             sorted(os.listdir(u'b1')))
+            delta = self.tree1.changes_from(self.tree1.basis_tree())
+            self.assertEqual([(u'with Dod\xe9', 'withdod-id', 'file')],
+                             delta.removed)
+            self.knownFailure("Mac OSX doesn't preserve unicode"
+                              " combining characters.")
+
         # Add
         bundle = self.get_valid_bundle(None, 'i18n-1')
 
@@ -884,6 +894,17 @@
         tree = bundle.revision_tree(self.b1.repository, 'revid1')
         self.assertEqual('revid1', tree.inventory.root.revision)
 
+    def test_install_revisions(self):
+        self.tree1 = self.make_branch_and_tree('b1')
+        self.b1 = self.tree1.branch
+        self.tree1.commit('message', rev_id='rev2a')
+        bundle = self.get_valid_bundle(None, 'rev2a')
+        branch2 = self.make_branch('b2')
+        self.assertFalse(branch2.repository.has_revision('rev2a'))
+        target_revision = bundle.install_revisions(branch2.repository)
+        self.assertTrue(branch2.repository.has_revision('rev2a'))
+        self.assertEqual('rev2a', target_revision)
+
 
 class V09BundleKnit2Tester(V08BundleTester):
 

=== modified file 'bzrlib/tests/test_bzrdir.py'
--- bzrlib/tests/test_bzrdir.py	2007-03-28 07:33:07 +0000
+++ bzrlib/tests/test_bzrdir.py	2007-04-01 06:19:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+    # Copyright (C) 2005, 2006, 2007 Canonical Ltd
 # 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -36,9 +36,19 @@
                            UnknownFormatError,
                            UnsupportedFormatError,
                            )
-from bzrlib.tests import TestCase, TestCaseWithTransport, test_sftp_transport
+from bzrlib.tests import (
+    TestCase,
+    TestCaseWithTransport,
+    test_sftp_transport
+    )
 from bzrlib.tests.HttpServer import HttpServer
+from bzrlib.tests.HTTPTestUtil import (
+    TestCaseWithTwoWebservers,
+    HTTPServerRedirecting,
+    )
+from bzrlib.tests.test_http import TestWithTransport_pycurl
 from bzrlib.transport import get_transport
+from bzrlib.transport.http._urllib import HttpTransport_urllib
 from bzrlib.transport.memory import MemoryServer
 from bzrlib.repofmt import knitrepo, weaverepo
 
@@ -764,3 +774,72 @@
         checkout_format = my_bzrdir.checkout_metadir()
         self.assertIsInstance(checkout_format.workingtree_format,
                               workingtree.WorkingTreeFormat3)
+
+
+class TestHTTPRedirectionLoop(object):
+    """Test redirection loop between two http servers.
+
+    This MUST be used by daughter classes that also inherit from
+    TestCaseWithTwoWebservers.
+
+    We can't inherit directly from TestCaseWithTwoWebservers or the
+    test framework will try to create an instance which cannot
+    run, its implementation being incomplete. 
+    """
+
+    # Should be defined by daughter classes to ensure redirection
+    # still use the same transport implementation (not currently
+    # enforced as it's a bit tricky to get right (see the FIXME
+    # in BzrDir.open_from_transport for the unique use case so
+    # far)
+    _qualifier = None
+
+    def create_transport_readonly_server(self):
+        return HTTPServerRedirecting()
+
+    def create_transport_secondary_server(self):
+        return HTTPServerRedirecting()
+
+    def setUp(self):
+        # Both servers redirect to each server creating a loop
+        super(TestHTTPRedirectionLoop, self).setUp()
+        # The redirections will point to the new server
+        self.new_server = self.get_readonly_server()
+        # The requests to the old server will be redirected
+        self.old_server = self.get_secondary_server()
+        # Configure the redirections
+        self.old_server.redirect_to(self.new_server.host, self.new_server.port)
+        self.new_server.redirect_to(self.old_server.host, self.old_server.port)
+
+    def _qualified_url(self, host, port):
+        return 'http+%s://%s:%s' % (self._qualifier, host, port)
+
+    def test_loop(self):
+        # Starting from either server should loop
+        old_url = self._qualified_url(self.old_server.host, 
+                                      self.old_server.port)
+        oldt = self._transport(old_url)
+        self.assertRaises(errors.NotBranchError,
+                          bzrdir.BzrDir.open_from_transport, oldt)
+        new_url = self._qualified_url(self.new_server.host, 
+                                      self.new_server.port)
+        newt = self._transport(new_url)
+        self.assertRaises(errors.NotBranchError,
+                          bzrdir.BzrDir.open_from_transport, newt)
+
+
+class TestHTTPRedirections_urllib(TestHTTPRedirectionLoop,
+                                  TestCaseWithTwoWebservers):
+    """Tests redirections for urllib implementation"""
+
+    _qualifier = 'urllib'
+    _transport = HttpTransport_urllib
+
+
+
+class TestHTTPRedirections_pycurl(TestWithTransport_pycurl,
+                                  TestHTTPRedirectionLoop,
+                                  TestCaseWithTwoWebservers):
+    """Tests redirections for pycurl implementation"""
+
+    _qualifier = 'pycurl'

=== modified file 'bzrlib/tests/test_dirstate.py'
--- bzrlib/tests/test_dirstate.py	2007-03-15 23:24:59 +0000
+++ bzrlib/tests/test_dirstate.py	2007-03-26 08:16:45 +0000
@@ -102,7 +102,9 @@
          b/g      g-file
          b/h\xc3\xa5  h-\xc3\xa5-file  #This is u'\xe5' encoded into utf-8
 
-        # Notice that a/e is an empty directory.
+        Notice that a/e is an empty directory.
+
+        :return: The dirstate, still write-locked.
         """
         packed_stat = 'AAAAREUHaIpFB2iKAAADAQAtkqUAAIGk'
         null_sha = 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'
@@ -179,6 +181,168 @@
         finally:
             state.unlock()
 
+    def create_basic_dirstate(self):
+        """Create a dirstate with a few files and directories.
+
+            a
+            b/
+              c
+              d/
+                e
+            f
+        """
+        tree = self.make_branch_and_tree('tree')
+        paths = ['a', 'b/', 'b/c', 'b/d/', 'b/d/e', 'f']
+        file_ids = ['a-id', 'b-id', 'c-id', 'd-id', 'e-id', 'f-id']
+        self.build_tree(['tree/' + p for p in paths])
+        tree.set_root_id('TREE_ROOT')
+        tree.add([p.rstrip('/') for p in paths], file_ids)
+        tree.commit('initial', rev_id='rev-1')
+        revision_id = 'rev-1'
+        # a_packed_stat = dirstate.pack_stat(os.stat('tree/a'))
+        t = self.get_transport().clone('tree')
+        a_text = t.get_bytes('a')
+        a_sha = osutils.sha_string(a_text)
+        a_len = len(a_text)
+        # b_packed_stat = dirstate.pack_stat(os.stat('tree/b'))
+        # c_packed_stat = dirstate.pack_stat(os.stat('tree/b/c'))
+        c_text = t.get_bytes('b/c')
+        c_sha = osutils.sha_string(c_text)
+        c_len = len(c_text)
+        # d_packed_stat = dirstate.pack_stat(os.stat('tree/b/d'))
+        # e_packed_stat = dirstate.pack_stat(os.stat('tree/b/d/e'))
+        e_text = t.get_bytes('b/d/e')
+        e_sha = osutils.sha_string(e_text)
+        e_len = len(e_text)
+        # f_packed_stat = dirstate.pack_stat(os.stat('tree/f'))
+        f_text = t.get_bytes('f')
+        f_sha = osutils.sha_string(f_text)
+        f_len = len(f_text)
+        null_stat = dirstate.DirState.NULLSTAT
+        expected = {
+            '':(('', '', 'TREE_ROOT'), [
+                  ('d', '', 0, False, null_stat),
+                  ('d', '', 0, False, revision_id),
+                ]),
+            'a':(('', 'a', 'a-id'), [
+                   ('f', '', 0, False, null_stat),
+                   ('f', a_sha, a_len, False, revision_id),
+                 ]),
+            'b':(('', 'b', 'b-id'), [
+                  ('d', '', 0, False, null_stat),
+                  ('d', '', 0, False, revision_id),
+                 ]),
+            'b/c':(('b', 'c', 'c-id'), [
+                    ('f', '', 0, False, null_stat),
+                    ('f', c_sha, c_len, False, revision_id),
+                   ]),
+            'b/d':(('b', 'd', 'd-id'), [
+                    ('d', '', 0, False, null_stat),
+                    ('d', '', 0, False, revision_id),
+                   ]),
+            'b/d/e':(('b/d', 'e', 'e-id'), [
+                      ('f', '', 0, False, null_stat),
+                      ('f', e_sha, e_len, False, revision_id),
+                     ]),
+            'f':(('', 'f', 'f-id'), [
+                  ('f', '', 0, False, null_stat),
+                  ('f', f_sha, f_len, False, revision_id),
+                 ]),
+        }
+        state = dirstate.DirState.from_tree(tree, 'dirstate')
+        try:
+            state.save()
+        finally:
+            state.unlock()
+        # Use a different object, to make sure nothing is pre-cached in memory.
+        state = dirstate.DirState.on_file('dirstate')
+        state.lock_read()
+        self.addCleanup(state.unlock)
+        self.assertEqual(dirstate.DirState.NOT_IN_MEMORY,
+                         state._dirblock_state)
+        # This is code is only really tested if we actually have to make more
+        # than one read, so set the page size to something smaller.
+        # We want it to contain about 2.2 records, so that we have a couple
+        # records that we can read per attempt
+        state._bisect_page_size = 200
+        return tree, state, expected
+
+    def create_duplicated_dirstate(self):
+        """Create a dirstate with a deleted and added entries.
+
+        This grabs a basic_dirstate, and then removes and re adds every entry
+        with a new file id.
+        """
+        tree, state, expected = self.create_basic_dirstate()
+        # Now we will just remove and add every file so we get an extra entry
+        # per entry. Unversion in reverse order so we handle subdirs
+        tree.unversion(['f-id', 'e-id', 'd-id', 'c-id', 'b-id', 'a-id'])
+        tree.add(['a', 'b', 'b/c', 'b/d', 'b/d/e', 'f'],
+                 ['a-id2', 'b-id2', 'c-id2', 'd-id2', 'e-id2', 'f-id2'])
+
+        # Update the expected dictionary.
+        for path in ['a', 'b', 'b/c', 'b/d', 'b/d/e', 'f']:
+            orig = expected[path]
+            path2 = path + '2'
+            # This record was deleted in the current tree
+            expected[path] = (orig[0], [dirstate.DirState.NULL_PARENT_DETAILS,
+                                        orig[1][1]])
+            new_key = (orig[0][0], orig[0][1], orig[0][2]+'2')
+            # And didn't exist in the basis tree
+            expected[path2] = (new_key, [orig[1][0],
+                                         dirstate.DirState.NULL_PARENT_DETAILS])
+
+        # We will replace the 'dirstate' file underneath 'state', but that is
+        # okay as lock as we unlock 'state' first.
+        state.unlock()
+        try:
+            new_state = dirstate.DirState.from_tree(tree, 'dirstate')
+            try:
+                new_state.save()
+            finally:
+                new_state.unlock()
+        finally:
+            # But we need to leave state in a read-lock because we already have
+            # a cleanup scheduled
+            state.lock_read()
+        return tree, state, expected
+
+    def create_renamed_dirstate(self):
+        """Create a dirstate with a few internal renames.
+
+        This takes the basic dirstate, and moves the paths around.
+        """
+        tree, state, expected = self.create_basic_dirstate()
+        # Rename a file
+        tree.rename_one('a', 'b/g')
+        # And a directory
+        tree.rename_one('b/d', 'h')
+
+        old_a = expected['a']
+        expected['a'] = (old_a[0], [('r', 'b/g', 0, False, ''), old_a[1][1]])
+        expected['b/g'] = (('b', 'g', 'a-id'), [old_a[1][0],
+                                                ('r', 'a', 0, False, '')])
+        old_d = expected['b/d']
+        expected['b/d'] = (old_d[0], [('r', 'h', 0, False, ''), old_d[1][1]])
+        expected['h'] = (('', 'h', 'd-id'), [old_d[1][0],
+                                             ('r', 'b/d', 0, False, '')])
+
+        old_e = expected['b/d/e']
+        expected['b/d/e'] = (old_e[0], [('r', 'h/e', 0, False, ''),
+                             old_e[1][1]])
+        expected['h/e'] = (('h', 'e', 'e-id'), [old_e[1][0],
+                                                ('r', 'b/d/e', 0, False, '')])
+
+        state.unlock()
+        try:
+            new_state = dirstate.DirState.from_tree(tree, 'dirstate')
+            try:
+                new_state.save()
+            finally:
+                new_state.unlock()
+        finally:
+            state.lock_read()
+        return tree, state, expected
 
 class TestTreeToDirState(TestCaseWithDirState):
 
@@ -206,7 +370,11 @@
              ])])
         state = dirstate.DirState.from_tree(tree, 'dirstate')
         self.check_state_with_reopen(expected_result, state)
-        state._validate()
+        state.lock_read()
+        try:
+            state._validate()
+        finally:
+            state.unlock()
 
     def test_2_parents_empty_to_dirstate(self):
         # create a parent by doing a commit
@@ -223,7 +391,11 @@
              ])])
         state = dirstate.DirState.from_tree(tree, 'dirstate')
         self.check_state_with_reopen(expected_result, state)
-        state._validate()
+        state.lock_read()
+        try:
+            state._validate()
+        finally:
+            state.unlock()
 
     def test_empty_unknowns_are_ignored_to_dirstate(self):
         """We should be able to create a dirstate for an empty tree."""
@@ -533,9 +705,9 @@
         finally:
             state.unlock()
         state = dirstate.DirState.on_file('dirstate')
-        state._validate()
         state.lock_read()
         try:
+            state._validate()
             self.assertEqual(expected_rows, list(state._iter_entries()))
         finally:
             state.unlock()
@@ -1563,171 +1735,9 @@
         self.assertPackStat('AAAbWEXm4FxF5uBmAAADCQBjLNIAAIGk', st)
 
 
-class TestBisect(TestCaseWithTransport):
+class TestBisect(TestCaseWithDirState):
     """Test the ability to bisect into the disk format."""
 
-    def create_basic_dirstate(self):
-        """Create a dirstate with a few files and directories.
-
-            a
-            b/
-              c
-              d/
-                e
-            f
-        """
-        tree = self.make_branch_and_tree('tree')
-        paths = ['a', 'b/', 'b/c', 'b/d/', 'b/d/e', 'f']
-        file_ids = ['a-id', 'b-id', 'c-id', 'd-id', 'e-id', 'f-id']
-        self.build_tree(['tree/' + p for p in paths])
-        tree.set_root_id('TREE_ROOT')
-        tree.add([p.rstrip('/') for p in paths], file_ids)
-        tree.commit('initial', rev_id='rev-1')
-        revision_id = 'rev-1'
-        # a_packed_stat = dirstate.pack_stat(os.stat('tree/a'))
-        t = self.get_transport().clone('tree')
-        a_text = t.get_bytes('a')
-        a_sha = osutils.sha_string(a_text)
-        a_len = len(a_text)
-        # b_packed_stat = dirstate.pack_stat(os.stat('tree/b'))
-        # c_packed_stat = dirstate.pack_stat(os.stat('tree/b/c'))
-        c_text = t.get_bytes('b/c')
-        c_sha = osutils.sha_string(c_text)
-        c_len = len(c_text)
-        # d_packed_stat = dirstate.pack_stat(os.stat('tree/b/d'))
-        # e_packed_stat = dirstate.pack_stat(os.stat('tree/b/d/e'))
-        e_text = t.get_bytes('b/d/e')
-        e_sha = osutils.sha_string(e_text)
-        e_len = len(e_text)
-        # f_packed_stat = dirstate.pack_stat(os.stat('tree/f'))
-        f_text = t.get_bytes('f')
-        f_sha = osutils.sha_string(f_text)
-        f_len = len(f_text)
-        null_stat = dirstate.DirState.NULLSTAT
-        expected = {
-            '':(('', '', 'TREE_ROOT'), [
-                  ('d', '', 0, False, null_stat),
-                  ('d', '', 0, False, revision_id),
-                ]),
-            'a':(('', 'a', 'a-id'), [
-                   ('f', '', 0, False, null_stat),
-                   ('f', a_sha, a_len, False, revision_id),
-                 ]),
-            'b':(('', 'b', 'b-id'), [
-                  ('d', '', 0, False, null_stat),
-                  ('d', '', 0, False, revision_id),
-                 ]),
-            'b/c':(('b', 'c', 'c-id'), [
-                    ('f', '', 0, False, null_stat),
-                    ('f', c_sha, c_len, False, revision_id),
-                   ]),
-            'b/d':(('b', 'd', 'd-id'), [
-                    ('d', '', 0, False, null_stat),
-                    ('d', '', 0, False, revision_id),
-                   ]),
-            'b/d/e':(('b/d', 'e', 'e-id'), [
-                      ('f', '', 0, False, null_stat),
-                      ('f', e_sha, e_len, False, revision_id),
-                     ]),
-            'f':(('', 'f', 'f-id'), [
-                  ('f', '', 0, False, null_stat),
-                  ('f', f_sha, f_len, False, revision_id),
-                 ]),
-        }
-        state = dirstate.DirState.from_tree(tree, 'dirstate')
-        try:
-            state.save()
-        finally:
-            state.unlock()
-        # Use a different object, to make sure nothing is pre-cached in memory.
-        state = dirstate.DirState.on_file('dirstate')
-        state.lock_read()
-        self.addCleanup(state.unlock)
-        self.assertEqual(dirstate.DirState.NOT_IN_MEMORY,
-                         state._dirblock_state)
-        # This is code is only really tested if we actually have to make more
-        # than one read, so set the page size to something smaller.
-        # We want it to contain about 2.2 records, so that we have a couple
-        # records that we can read per attempt
-        state._bisect_page_size = 200
-        return tree, state, expected
-
-    def create_duplicated_dirstate(self):
-        """Create a dirstate with a deleted and added entries.
-
-        This grabs a basic_dirstate, and then removes and re adds every entry
-        with a new file id.
-        """
-        tree, state, expected = self.create_basic_dirstate()
-        # Now we will just remove and add every file so we get an extra entry
-        # per entry. Unversion in reverse order so we handle subdirs
-        tree.unversion(['f-id', 'e-id', 'd-id', 'c-id', 'b-id', 'a-id'])
-        tree.add(['a', 'b', 'b/c', 'b/d', 'b/d/e', 'f'],
-                 ['a-id2', 'b-id2', 'c-id2', 'd-id2', 'e-id2', 'f-id2'])
-
-        # Update the expected dictionary.
-        for path in ['a', 'b', 'b/c', 'b/d', 'b/d/e', 'f']:
-            orig = expected[path]
-            path2 = path + '2'
-            # This record was deleted in the current tree
-            expected[path] = (orig[0], [dirstate.DirState.NULL_PARENT_DETAILS,
-                                        orig[1][1]])
-            new_key = (orig[0][0], orig[0][1], orig[0][2]+'2')
-            # And didn't exist in the basis tree
-            expected[path2] = (new_key, [orig[1][0],
-                                         dirstate.DirState.NULL_PARENT_DETAILS])
-
-        # We will replace the 'dirstate' file underneath 'state', but that is
-        # okay as lock as we unlock 'state' first.
-        state.unlock()
-        try:
-            new_state = dirstate.DirState.from_tree(tree, 'dirstate')
-            try:
-                new_state.save()
-            finally:
-                new_state.unlock()
-        finally:
-            # But we need to leave state in a read-lock because we already have
-            # a cleanup scheduled
-            state.lock_read()
-        return tree, state, expected
-
-    def create_renamed_dirstate(self):
-        """Create a dirstate with a few internal renames.
-
-        This takes the basic dirstate, and moves the paths around.
-        """
-        tree, state, expected = self.create_basic_dirstate()
-        # Rename a file
-        tree.rename_one('a', 'b/g')
-        # And a directory
-        tree.rename_one('b/d', 'h')
-
-        old_a = expected['a']
-        expected['a'] = (old_a[0], [('r', 'b/g', 0, False, ''), old_a[1][1]])
-        expected['b/g'] = (('b', 'g', 'a-id'), [old_a[1][0],
-                                                ('r', 'a', 0, False, '')])
-        old_d = expected['b/d']
-        expected['b/d'] = (old_d[0], [('r', 'h', 0, False, ''), old_d[1][1]])
-        expected['h'] = (('', 'h', 'd-id'), [old_d[1][0],
-                                             ('r', 'b/d', 0, False, '')])
-
-        old_e = expected['b/d/e']
-        expected['b/d/e'] = (old_e[0], [('r', 'h/e', 0, False, ''),
-                             old_e[1][1]])
-        expected['h/e'] = (('h', 'e', 'e-id'), [old_e[1][0],
-                                                ('r', 'b/d/e', 0, False, '')])
-
-        state.unlock()
-        try:
-            new_state = dirstate.DirState.from_tree(tree, 'dirstate')
-            try:
-                new_state.save()
-            finally:
-                new_state.unlock()
-        finally:
-            state.lock_read()
-        return tree, state, expected
 
     def assertBisect(self, expected_map, map_keys, state, paths):
         """Assert that bisecting for paths returns the right result.
@@ -2040,3 +2050,59 @@
         for path in paths:
             self.assertBisect(dirblocks, split_dirblocks, path, cache=cache)
 
+
+class TestDirstateValidation(TestCaseWithDirState):
+
+    def test_validate_correct_dirstate(self):
+        state = self.create_complex_dirstate()
+        state._validate()
+        state.unlock()
+        # and make sure we can also validate with a read lock
+        state.lock_read()
+        try:
+            state._validate()
+        finally:
+            state.unlock()
+
+    def test_dirblock_not_sorted(self):
+        tree, state, expected = self.create_renamed_dirstate()
+        state._read_dirblocks_if_needed()
+        last_dirblock = state._dirblocks[-1]
+        # we're appending to the dirblock, but this name comes before some of
+        # the existing names; that's wrong
+        last_dirblock[1].append(
+            (('h', 'aaaa', 'a-id'),
+             [('a', '', 0, False, ''),
+              ('a', '', 0, False, '')]))
+        e = self.assertRaises(AssertionError,
+            state._validate)
+        self.assertContainsRe(str(e), 'not sorted')
+
+    def test_dirblock_name_mismatch(self):
+        tree, state, expected = self.create_renamed_dirstate()
+        state._read_dirblocks_if_needed()
+        last_dirblock = state._dirblocks[-1]
+        # add an entry with the wrong directory name
+        last_dirblock[1].append(
+            (('', 'z', 'a-id'),
+             [('a', '', 0, False, ''),
+              ('a', '', 0, False, '')]))
+        e = self.assertRaises(AssertionError,
+            state._validate)
+        self.assertContainsRe(str(e),
+            "doesn't match directory name")
+
+    def test_dirblock_missing_rename(self):
+        tree, state, expected = self.create_renamed_dirstate()
+        state._read_dirblocks_if_needed()
+        last_dirblock = state._dirblocks[-1]
+        # make another entry for a-id, without a correct 'r' pointer to
+        # the real occurrence in the working tree
+        last_dirblock[1].append(
+            (('h', 'z', 'a-id'),
+             [('a', '', 0, False, ''),
+              ('a', '', 0, False, '')]))
+        e = self.assertRaises(AssertionError,
+            state._validate)
+        self.assertContainsRe(str(e),
+            'file a-id is absent in row')

=== modified file 'bzrlib/tests/test_fetch.py'
--- bzrlib/tests/test_fetch.py	2007-03-06 06:35:00 +0000
+++ bzrlib/tests/test_fetch.py	2007-03-28 13:56:45 +0000
@@ -18,7 +18,11 @@
 import re
 import sys
 
-from bzrlib import bzrdir, repository
+from bzrlib import (
+    bzrdir,
+    errors,
+    repository,
+    )
 from bzrlib.branch import Branch
 from bzrlib.bzrdir import BzrDir
 from bzrlib.builtins import merge
@@ -155,6 +159,14 @@
         # even though the text, name, parent_id, etc., were unchanged.
         self.assertTrue('rev2' in root_knit)
 
+    def test_fetch_incompatible(self):
+        knit_tree = self.make_branch_and_tree('knit', format='knit')
+        knit3_tree = self.make_branch_and_tree('knit3',
+            format='dirstate-with-subtree')
+        knit3_tree.commit('blah')
+        self.assertRaises(errors.IncompatibleRepositories,
+                          knit_tree.branch.fetch, knit3_tree.branch)
+
 
 class TestMergeFetch(TestCaseWithTransport):
 

=== modified file 'bzrlib/tests/test_http.py'
--- bzrlib/tests/test_http.py	2007-03-05 20:51:42 +0000
+++ bzrlib/tests/test_http.py	2007-03-14 16:39:24 +0000
@@ -26,8 +26,11 @@
 import threading
 
 import bzrlib
-from bzrlib import errors
-from bzrlib import osutils
+from bzrlib import (
+    errors,
+    osutils,
+    urlutils,
+    )
 from bzrlib.tests import (
     TestCase,
     TestSkipped,
@@ -42,20 +45,24 @@
     BadStatusRequestHandler,
     FakeProxyRequestHandler,
     ForbiddenRequestHandler,
+    HTTPServerRedirecting,
     InvalidStatusRequestHandler,
     NoRangeRequestHandler,
     SingleRangeRequestHandler,
+    TestCaseWithRedirectedWebserver,
     TestCaseWithTwoWebservers,
     TestCaseWithWebserver,
     WallRequestHandler,
     )
 from bzrlib.transport import (
+    do_catching_redirections,
     get_transport,
     Transport,
     )
 from bzrlib.transport.http import (
     extract_auth,
     HttpTransportBase,
+    _urllib2_wrappers,
     )
 from bzrlib.transport.http._urllib import HttpTransport_urllib
 
@@ -946,3 +953,195 @@
                         TestRanges,
                         TestCaseWithWebserver):
     """Test the Range header in GET methods for pycurl implementation"""
+
+
+class TestHTTPRedirections(object):
+    """Test redirection between http servers.
+
+    This MUST be used by daughter classes that also inherit from
+    TestCaseWithRedirectedWebserver.
+
+    We can't inherit directly from TestCaseWithTwoWebservers or the
+    test framework will try to create an instance which cannot
+    run, its implementation being incomplete. 
+    """
+
+    def create_transport_secondary_server(self):
+        """Create the secondary server redirecting to the primary server"""
+        new = self.get_readonly_server()
+
+        redirecting = HTTPServerRedirecting()
+        redirecting.redirect_to(new.host, new.port)
+        return redirecting
+
+    def setUp(self):
+        super(TestHTTPRedirections, self).setUp()
+        self.build_tree_contents([('a', '0123456789'),
+                                  ('bundle',
+                                  '# Bazaar revision bundle v0.9\n#\n')
+                                  ],)
+
+        self.old_transport = self._transport(self.old_server.get_url())
+
+    def test_redirected(self):
+        self.assertRaises(errors.RedirectRequested, self.old_transport.get, 'a')
+        t = self._transport(self.new_server.get_url())
+        self.assertEqual('0123456789', t.get('a').read())
+
+    def test_read_redirected_bundle_from_url(self):
+        from bzrlib.bundle import read_bundle_from_url
+        url = self.old_transport.abspath('bundle')
+        bundle = read_bundle_from_url(url)
+        # If read_bundle_from_url was successful we get an empty bundle
+        self.assertEqual([], bundle.revisions)
+
+
+class TestHTTPRedirections_urllib(TestHTTPRedirections,
+                                  TestCaseWithRedirectedWebserver):
+    """Tests redirections for urllib implementation"""
+
+    _transport = HttpTransport_urllib
+
+
+
+class TestHTTPRedirections_pycurl(TestWithTransport_pycurl,
+                                  TestHTTPRedirections,
+                                  TestCaseWithRedirectedWebserver):
+    """Tests redirections for pycurl implementation"""
+
+
+class RedirectedRequest(_urllib2_wrappers.Request):
+    """Request following redirections"""
+
+    init_orig = _urllib2_wrappers.Request.__init__
+
+    def __init__(self, method, url, *args, **kwargs):
+        RedirectedRequest.init_orig(self, method, url, args, kwargs)
+        self.follow_redirections = True
+
+
+class TestHTTPSilentRedirections_urllib(TestCaseWithRedirectedWebserver):
+    """Test redirections provided by urllib.
+
+    http implementations do not redirect silently anymore (they
+    do not redirect at all in fact). The mechanism is still in
+    place at the _urllib2_wrappers.Request level and these tests
+    exercise it.
+
+    For the pycurl implementation
+    the redirection have been deleted as we may deprecate pycurl
+    and I have no place to keep a working implementation.
+    -- vila 20070212
+    """
+
+    _transport = HttpTransport_urllib
+
+    def setUp(self):
+        super(TestHTTPSilentRedirections_urllib, self).setUp()
+        self.setup_redirected_request()
+        self.addCleanup(self.cleanup_redirected_request)
+        self.build_tree_contents([('a','a'),
+                                  ('1/',),
+                                  ('1/a', 'redirected once'),
+                                  ('2/',),
+                                  ('2/a', 'redirected twice'),
+                                  ('3/',),
+                                  ('3/a', 'redirected thrice'),
+                                  ('4/',),
+                                  ('4/a', 'redirected 4 times'),
+                                  ('5/',),
+                                  ('5/a', 'redirected 5 times'),
+                                  ],)
+
+        self.old_transport = self._transport(self.old_server.get_url())
+
+    def setup_redirected_request(self):
+        self.original_class = _urllib2_wrappers.Request
+        _urllib2_wrappers.Request = RedirectedRequest
+
+    def cleanup_redirected_request(self):
+        _urllib2_wrappers.Request = self.original_class
+
+    def create_transport_secondary_server(self):
+        """Create the secondary server, redirections are defined in the tests"""
+        return HTTPServerRedirecting()
+
+    def test_one_redirection(self):
+        t = self.old_transport
+
+        req = RedirectedRequest('GET', t.abspath('a'))
+        req.follow_redirections = True
+        new_prefix = 'http://%s:%s' % (self.new_server.host,
+                                       self.new_server.port)
+        self.old_server.redirections = \
+            [('(.*)', r'%s/1\1' % (new_prefix), 301),]
+        self.assertEquals('redirected once',t._perform(req).read())
+
+    def test_five_redirections(self):
+        t = self.old_transport
+
+        req = RedirectedRequest('GET', t.abspath('a'))
+        req.follow_redirections = True
+        old_prefix = 'http://%s:%s' % (self.old_server.host,
+                                       self.old_server.port)
+        new_prefix = 'http://%s:%s' % (self.new_server.host,
+                                       self.new_server.port)
+        self.old_server.redirections = \
+            [('/1(.*)', r'%s/2\1' % (old_prefix), 302),
+             ('/2(.*)', r'%s/3\1' % (old_prefix), 303),
+             ('/3(.*)', r'%s/4\1' % (old_prefix), 307),
+             ('/4(.*)', r'%s/5\1' % (new_prefix), 301),
+             ('(/[^/]+)', r'%s/1\1' % (old_prefix), 301),
+             ]
+        self.assertEquals('redirected 5 times',t._perform(req).read())
+
+
+class TestDoCatchRedirections(TestCaseWithRedirectedWebserver):
+    """Test transport.do_catching_redirections.
+
+    We arbitrarily choose to use urllib transports
+    """
+
+    _transport = HttpTransport_urllib
+
+    def setUp(self):
+        super(TestDoCatchRedirections, self).setUp()
+        self.build_tree_contents([('a', '0123456789'),],)
+
+        self.old_transport = self._transport(self.old_server.get_url())
+
+    def get_a(self, transport):
+        return transport.get('a')
+
+    def test_no_redirection(self):
+        t = self._transport(self.new_server.get_url())
+
+        # We use None for redirected so that we fail if redirected
+        self.assertEquals('0123456789',
+                          do_catching_redirections(self.get_a, t, None).read())
+
+    def test_one_redirection(self):
+        self.redirections = 0
+
+        def redirected(transport, exception, redirection_notice):
+            self.redirections += 1
+            dir, file = urlutils.split(exception.target)
+            return self._transport(dir)
+
+        self.assertEquals('0123456789',
+                          do_catching_redirections(self.get_a,
+                                                   self.old_transport,
+                                                   redirected
+                                                   ).read())
+        self.assertEquals(1, self.redirections)
+
+    def test_redirection_loop(self):
+
+        def redirected(transport, exception, redirection_notice):
+            # By using the redirected url as a base dir for the
+            # *old* transport, we create a loop: a => a/a =>
+            # a/a/a
+            return self.old_transport.clone(exception.target)
+
+        self.assertRaises(errors.TooManyRedirections, do_catching_redirections,
+                          self.get_a, self.old_transport, redirected)

=== modified file 'bzrlib/tests/test_inv.py'
--- bzrlib/tests/test_inv.py	2007-03-11 23:05:49 +0000
+++ bzrlib/tests/test_inv.py	2007-04-04 02:38:10 +0000
@@ -354,3 +354,16 @@
         inv = Inventory('tree-root-123')
         inv.add(TreeReference('nested-id', 'nested', parent_id='tree-root-123',
                               revision='rev', reference_revision='rev2'))
+
+
+class TestEncoding(TestCase):
+
+    def test_error_encoding(self):
+        inv = Inventory('tree-root')
+        inv.add(InventoryFile('a-id', u'\u1234', 'tree-root'))
+        try:
+            inv.add(InventoryFile('b-id', u'\u1234', 'tree-root'))
+        except errors.BzrError, e:
+            self.assertContainsRe(str(e), u'\u1234'.encode('utf-8'))
+        else:
+            self.fail('BzrError not raised')

=== modified file 'bzrlib/tests/test_merge_core.py'
--- bzrlib/tests/test_merge_core.py	2007-02-26 21:17:03 +0000
+++ bzrlib/tests/test_merge_core.py	2007-03-25 12:46:04 +0000
@@ -552,8 +552,8 @@
         a_wt = self.make_branch_and_tree('a')
         file('a/un','wb').write('UN')
         file('a/deux','wb').write('DEUX')
-        a_wt.add('un', 'un')
-        a_wt.add('deux', 'deux')
+        a_wt.add('un', 'un-id')
+        a_wt.add('deux', 'deux-id')
         a_wt.commit('r0', rev_id='r0')
         self.run_bzr('branch', 'a', 'b')
         b_wt = WorkingTree.open('b')

=== modified file 'bzrlib/tests/test_merge_directive.py'
--- bzrlib/tests/test_merge_directive.py	2007-03-23 03:37:01 +0000
+++ bzrlib/tests/test_merge_directive.py	2007-04-01 04:06:14 +0000
@@ -295,3 +295,33 @@
         md.message = 'Commit of rev2a with special message'
         message = md.to_email('pqm@example.com', tree_a.branch)
         self.assertContainsRe(message.as_string(), EMAIL2)
+
+    def test_install_revisions_branch(self):
+        tree_a, tree_b, branch_c = self.make_trees()
+        md = merge_directive.MergeDirective.from_objects(
+            tree_a.branch.repository, 'rev2a', 500, 36, tree_b.branch.base,
+            patch_type=None, public_branch=tree_a.branch.base)
+        self.assertFalse(tree_b.branch.repository.has_revision('rev2a'))
+        revision = md.install_revisions(tree_b.branch.repository)
+        self.assertEqual('rev2a', revision)
+        self.assertTrue(tree_b.branch.repository.has_revision('rev2a'))
+
+    def test_install_revisions_bundle(self):
+        tree_a, tree_b, branch_c = self.make_trees()
+        md = merge_directive.MergeDirective.from_objects(
+            tree_a.branch.repository, 'rev2a', 500, 36, tree_b.branch.base,
+            patch_type='bundle', public_branch=tree_a.branch.base)
+        self.assertFalse(tree_b.branch.repository.has_revision('rev2a'))
+        revision = md.install_revisions(tree_b.branch.repository)
+        self.assertEqual('rev2a', revision)
+        self.assertTrue(tree_b.branch.repository.has_revision('rev2a'))
+
+    def test_get_target_revision_nofetch(self):
+        tree_a, tree_b, branch_c = self.make_trees()
+        tree_b.branch.fetch(tree_a.branch)
+        md = merge_directive.MergeDirective.from_objects(
+            tree_a.branch.repository, 'rev2a', 500, 36, tree_b.branch.base,
+            patch_type=None, public_branch=tree_a.branch.base)
+        md.source_branch = '/dev/null'
+        revision = md.install_revisions(tree_b.branch.repository)
+        self.assertEqual('rev2a', revision)

=== modified file 'bzrlib/tests/test_selftest.py'
--- bzrlib/tests/test_selftest.py	2007-03-28 07:33:07 +0000
+++ bzrlib/tests/test_selftest.py	2007-04-04 05:19:38 +0000
@@ -1162,6 +1162,8 @@
         """The bzrlib hooks should be sanitised by setUp."""
         self.assertEqual(bzrlib.branch.BranchHooks(),
             bzrlib.branch.Branch.hooks)
+        self.assertEqual(bzrlib.transport.smart.SmartServerHooks(),
+            bzrlib.transport.smart.SmartTCPServer.hooks)
 
     def test__gather_lsprof_in_benchmarks(self):
         """When _gather_lsprof_in_benchmarks is on, accumulate profile data.
@@ -1429,6 +1431,19 @@
         # runners.
         self.assertIsInstance(KnownFailure(""), AssertionError)
 
+    def test_expect_failure(self):
+        try:
+            self.expectFailure("Doomed to failure", self.assertTrue, False)
+        except KnownFailure, e:
+            self.assertEqual('Doomed to failure', e.args[0])
+        try:
+            self.expectFailure("Doomed to failure", self.assertTrue, True)
+        except AssertionError, e:
+            self.assertEqual('Unexpected success.  Should have failed:'
+                             ' Doomed to failure', e.args[0])
+        else:
+            self.fail('Assertion not raised')
+
 
 class TestFeature(TestCase):
 

=== modified file 'bzrlib/tests/test_smart_transport.py'
--- bzrlib/tests/test_smart_transport.py	2006-11-21 01:08:52 +0000
+++ bzrlib/tests/test_smart_transport.py	2007-04-05 00:39:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -771,6 +771,7 @@
     def test_get_error_unexpected(self):
         """Error reported by server with no specific representation"""
         class FlakyTransport(object):
+            base = 'a_url'
             def get_bytes(self, path):
                 raise Exception("some random exception from inside server")
         server = smart.SmartTCPServer(backing_transport=FlakyTransport())
@@ -808,14 +809,38 @@
         self.server = smart.SmartTCPServer(self.backing_transport)
         self.server.start_background_thread()
         self.transport = smart.SmartTCPTransport(self.server.get_url())
+        self.addCleanup(self.tearDownServer)
 
-    def tearDown(self):
+    def tearDownServer(self):
         if getattr(self, 'transport', None):
             self.transport.disconnect()
+            del self.transport
         if getattr(self, 'server', None):
             self.server.stop_background_thread()
-        super(SmartTCPTests, self).tearDown()
-        
+            del self.server
+
+
+class TestServerSocketUsage(SmartTCPTests):
+
+    def test_server_setup_teardown(self):
+        """It should be safe to teardown the server with no requests."""
+        self.setUpServer()
+        server = self.server
+        transport = smart.SmartTCPTransport(self.server.get_url())
+        self.tearDownServer()
+        self.assertRaises(errors.ConnectionError, transport.has, '.')
+
+    def test_server_closes_listening_sock_on_shutdown_after_request(self):
+        """The server should close its listening socket when it's stopped."""
+        self.setUpServer()
+        server = self.server
+        self.transport.has('.')
+        self.tearDownServer()
+        # if the listening socket has closed, we should get a BADFD error
+        # when connecting, rather than a hang.
+        transport = smart.SmartTCPTransport(server.get_url())
+        self.assertRaises(errors.ConnectionError, transport.has, '.')
+
 
 class WritableEndToEndTests(SmartTCPTests):
     """Client to server tests that require a writable transport."""
@@ -901,7 +926,47 @@
         self.setUpServer(readonly=True)
         self.assertRaises(errors.TransportNotPossible, self.transport.mkdir,
             'foo')
-        
+
+
+class TestServerHooks(SmartTCPTests):
+
+    def capture_server_call(self, backing_url, public_url):
+        """Record a server_started|stopped hook firing."""
+        self.hook_calls.append((backing_url, public_url))
+
+    def test_server_started_hook(self):
+        """The server_started hook fires when the server is started."""
+        self.hook_calls = []
+        smart.SmartTCPServer.hooks.install_hook('server_started',
+            self.capture_server_call)
+        self.setUpServer()
+        # at this point, the server will be starting a thread up.
+        # there is no indicator at the moment, so bodge it by doing a request.
+        self.transport.has('.')
+        self.assertEqual([(self.backing_transport.base, self.transport.base)],
+            self.hook_calls)
+
+    def test_server_stopped_hook_simple(self):
+        """The server_stopped hook fires when the server is stopped."""
+        self.hook_calls = []
+        smart.SmartTCPServer.hooks.install_hook('server_stopped',
+            self.capture_server_call)
+        self.setUpServer()
+        result = [(self.backing_transport.base, self.transport.base)]
+        # check the stopping message isn't emitted up front.
+        self.assertEqual([], self.hook_calls)
+        # nor after a single message
+        self.transport.has('.')
+        self.assertEqual([], self.hook_calls)
+        # clean up the server
+        server = self.server
+        self.tearDownServer()
+        # now it should have fired.
+        self.assertEqual(result, self.hook_calls)
+
+# TODO: test that when the server suffers an exception that it calls the
+# server-stopped hook.
+
 
 class SmartServerRequestHandlerTests(tests.TestCaseWithTransport):
     """Test that call directly into the handler logic, bypassing the network."""
@@ -1478,8 +1543,12 @@
             'Content-Length: 6\r\n'
             '\r\n'
             'hello\n')
-        request_handler = SmartRequestHandler(
-            socket, ('localhost', 80), httpd)
+        # Beware: the ('localhost', 80) below is the
+        # client_address parameter, but we don't have one because
+        # we have defined a socket which is not bound to an
+        # address. The test framework never uses this client
+        # address, so far...
+        request_handler = SmartRequestHandler(socket, ('localhost', 80), httpd)
         response = socket.writefile.getvalue()
         self.assertStartsWith(response, 'HTTP/1.0 200 ')
         # This includes the end of the HTTP headers, and all the body.

=== modified file 'bzrlib/tests/test_strace.py'
--- bzrlib/tests/test_strace.py	2007-03-27 07:37:12 +0000
+++ bzrlib/tests/test_strace.py	2007-04-02 15:50:01 +0000
@@ -17,6 +17,7 @@
 
 """Tests for the strace-invoking support."""
 
+import errno
 import subprocess
 
 from bzrlib.strace import StraceFeature, strace, StraceResult

=== modified file 'bzrlib/tests/test_transport_implementations.py'
--- bzrlib/tests/test_transport_implementations.py	2007-03-28 07:33:07 +0000
+++ bzrlib/tests/test_transport_implementations.py	2007-04-01 06:19:16 +0000
@@ -42,15 +42,6 @@
 import bzrlib.transport
 
 
-def _append(fn, txt):
-    """Append the given text (file-like object) to the supplied filename."""
-    f = open(fn, 'ab')
-    try:
-        f.write(txt.read())
-    finally:
-        f.close()
-
-
 class TransportTests(TestTransportImplementation):
 
     def check_transport_contents(self, content, transport, relpath):

=== modified file 'bzrlib/tests/workingtree_implementations/test_commit.py'
--- bzrlib/tests/workingtree_implementations/test_commit.py	2007-03-20 00:49:11 +0000
+++ bzrlib/tests/workingtree_implementations/test_commit.py	2007-03-23 20:19:01 +0000
@@ -101,7 +101,24 @@
                           tree.commit,
                           'foo',
                           local=True)
- 
+
+    def test_commit_merged_kind_change(self):
+        """Test merging a kind change.
+
+        Test making a kind change in a working tree, and then merging that
+        from another. When committed it should commit the new kind.
+        """
+        wt = self.make_branch_and_tree('.')
+        self.build_tree(['a'])
+        wt.add(['a'])
+        wt.commit('commit one')
+        wt2 = wt.bzrdir.sprout('to').open_workingtree()
+        os.remove('a')
+        os.mkdir('a')
+        wt.commit('changed kind')
+        wt2.merge_from_branch(wt.branch)
+        wt2.commit('merged kind change')
+
     def test_local_commit_ignores_master(self):
         # a --local commit does not require access to the master branch
         # at all, or even for it to exist.

=== modified file 'bzrlib/tests/workingtree_implementations/test_inv.py'
--- bzrlib/tests/workingtree_implementations/test_inv.py	2007-03-26 07:11:40 +0000
+++ bzrlib/tests/workingtree_implementations/test_inv.py	2007-04-02 17:32:40 +0000
@@ -124,3 +124,88 @@
                                   self.wt, self.builder)
         # expected outcome - file_1 has a revision id of '2'
         self.assertEqual(self.file_active.revision, '2')
+
+
+class TestApplyInventoryDelta(TestCaseWithWorkingTree):
+
+    def test_add(self):
+        wt = self.make_branch_and_tree('.')
+        wt.lock_write()
+        self.addCleanup(wt.unlock)
+        root_id = wt.get_root_id()
+        wt.apply_inventory_delta([(None, 'bar/foo', 'foo-id',
+            inventory.InventoryFile('foo-id', 'foo', parent_id='bar-id')),
+            (None, 'bar', 'bar-id', inventory.InventoryDirectory('bar-id',
+            'bar', parent_id=root_id))])
+        self.assertEqual('bar/foo', wt.inventory.id2path('foo-id'))
+        self.assertEqual('bar', wt.inventory.id2path('bar-id'))
+
+    def test_remove(self):
+        wt = self.make_branch_and_tree('.')
+        wt.lock_write()
+        self.addCleanup(wt.unlock)
+        self.build_tree(['foo/', 'foo/bar'])
+        wt.add(['foo', 'foo/bar'], ['foo-id', 'bar-id'])
+        wt.apply_inventory_delta([('foo', None, 'foo-id', None),
+                                  ('foo/bar', None, 'bar-id', None)])
+        self.assertIs(None, wt.path2id('foo'))
+
+    def test_rename_file(self):
+        wt = self.make_branch_and_tree('.')
+        wt.lock_write()
+        root_id = wt.get_root_id()
+        self.addCleanup(wt.unlock)
+        self.build_tree(['foo/', 'foo/bar', 'baz/'])
+        wt.add(['foo', 'foo/bar', 'baz'],
+               ['foo-id', 'bar-id', 'baz-id'])
+        wt.apply_inventory_delta([('foo/bar', 'baz/bar', 'bar-id',
+            inventory.InventoryFile('bar-id', 'bar', 'baz-id'))])
+        self.assertEqual('baz/bar', wt.id2path('bar-id'))
+
+    def test_rename_swap(self):
+        """Test the swap-names edge case.
+
+        foo and bar should swap names, but retain their children.  If this
+        works, any simpler rename ought to work.
+        """
+        wt = self.make_branch_and_tree('.')
+        wt.lock_write()
+        root_id = wt.get_root_id()
+        self.addCleanup(wt.unlock)
+        self.build_tree(['foo/', 'foo/bar', 'baz/', 'baz/qux'])
+        wt.add(['foo', 'foo/bar', 'baz', 'baz/qux'],
+               ['foo-id', 'bar-id', 'baz-id', 'qux-id'])
+        wt.apply_inventory_delta([('foo', 'baz', 'foo-id',
+            inventory.InventoryDirectory('foo-id', 'baz', root_id)),
+            ('baz', 'foo', 'baz-id',
+            inventory.InventoryDirectory('baz-id', 'foo', root_id))])
+        self.assertEqual('baz/bar', wt.id2path('bar-id'))
+        self.assertEqual('foo/qux', wt.id2path('qux-id'))
+
+    def test_child_rename_ordering(self):
+        """Test the rename-parent, move child edge case.
+
+        (A naive implementation may move the parent first, and then be
+         unable to find the child.)
+        """
+        wt = self.make_branch_and_tree('.')
+        root_id = wt.get_root_id()
+        self.build_tree(['dir/', 'dir/child', 'other/'])
+        wt.add(['dir', 'dir/child', 'other'],
+               ['dir-id', 'child-id', 'other-id'])
+        wt.apply_inventory_delta([('dir', 'dir2', 'dir-id',
+            inventory.InventoryDirectory('dir-id', 'dir2', root_id)),
+            ('dir/child', 'other/child', 'child-id',
+             inventory.InventoryFile('child-id', 'child', 'other-id'))])
+        self.assertEqual('dir2', wt.id2path('dir-id'))
+        self.assertEqual('other/child', wt.id2path('child-id'))
+
+    def test_replace_root(self):
+        wt = self.make_branch_and_tree('.')
+        wt.lock_write()
+        self.addCleanup(wt.unlock)
+
+        root_id = wt.get_root_id()
+        wt.apply_inventory_delta([('', None, root_id, None),
+            (None, '', 'root-id',
+             inventory.InventoryDirectory('root-id', '', None))])

=== modified file 'bzrlib/tests/workingtree_implementations/test_move.py'
--- bzrlib/tests/workingtree_implementations/test_move.py	2007-03-07 03:09:14 +0000
+++ bzrlib/tests/workingtree_implementations/test_move.py	2007-03-22 23:47:20 +0000
@@ -54,6 +54,7 @@
         tree.commit('initial commit')
         self.assertEqual([('a1', 'sub1/a1')],
             tree.move(['a1'], to_dir='sub1', after=False))
+        tree._validate()
 
     def test_move_correct_call_unnamed(self):
         """tree.move has the deprecated parameter 'to_name'.
@@ -66,6 +67,7 @@
         tree.commit('initial commit')
         self.assertEqual([('a1', 'sub1/a1')],
             tree.move(['a1'], 'sub1', after=False))
+        tree._validate()
 
     def test_move_deprecated_wrong_call(self):
         """tree.move has the deprecated parameter 'to_name'.
@@ -79,6 +81,7 @@
         self.assertRaises(TypeError, tree.move, ['a1'],
                           to_this_parameter_does_not_exist='sub1',
                           after=False)
+        tree._validate()
 
     def test_move_deprecated_call(self):
         """tree.move has the deprecated parameter 'to_name'.
@@ -100,6 +103,7 @@
             # since it was deprecated before the class was introduced.
             if not isinstance(self.workingtree_format, WorkingTreeFormat4):
                 raise
+        tree._validate()
 
     def test_move_target_not_dir(self):
         tree = self.make_branch_and_tree('.')
@@ -109,6 +113,7 @@
 
         self.assertRaises(errors.BzrMoveFailedError,
                           tree.move, ['a'], 'not-a-dir')
+        tree._validate()
 
     def test_move_non_existent(self):
         tree = self.make_branch_and_tree('.')
@@ -119,6 +124,7 @@
                           tree.move, ['not-a-file'], 'a')
         self.assertRaises(errors.BzrMoveFailedError,
                           tree.move, ['not-a-file'], '')
+        tree._validate()
 
     def test_move_target_not_versioned(self):
         tree = self.make_branch_and_tree('.')
@@ -127,6 +133,7 @@
         tree.commit('initial', rev_id='rev-1')
         self.assertRaises(errors.BzrMoveFailedError,
                           tree.move, ['b'], 'a')
+        tree._validate()
 
     def test_move_unversioned(self):
         tree = self.make_branch_and_tree('.')
@@ -135,6 +142,7 @@
         tree.commit('initial', rev_id='rev-1')
         self.assertRaises(errors.BzrMoveFailedError,
                           tree.move, ['b'], 'a')
+        tree._validate()
 
     def test_move_multi_unversioned(self):
         tree = self.make_branch_and_tree('.')
@@ -157,6 +165,7 @@
                                    ('d', 'd-id')], tree)
         self.assertTreeLayout([('', root_id), ('a', 'a-id'), ('c', 'c-id'),
                                ('d', 'd-id')], tree.basis_tree())
+        tree._validate()
 
     def test_move_subdir(self):
         tree = self.make_branch_and_tree('.')
@@ -177,6 +186,7 @@
                                ('b/c', 'c-id')], tree.basis_tree())
         self.failIfExists('a')
         self.assertFileEqual(a_contents, 'b/a')
+        tree._validate()
 
     def test_move_parent_dir(self):
         tree = self.make_branch_and_tree('.')
@@ -193,6 +203,7 @@
                                ('b/c', 'c-id')], tree.basis_tree())
         self.failIfExists('b/c')
         self.assertFileEqual(c_contents, 'c')
+        tree._validate()
 
     def test_move_fail_consistent(self):
         tree = self.make_branch_and_tree('.')
@@ -214,6 +225,7 @@
                                    ('b/c', 'c-id')], tree)
         self.assertTreeLayout([('', root_id), ('a', 'a-id'), ('b', 'b-id'),
                                ('c', 'c-id')], tree.basis_tree())
+        tree._validate()
 
     def test_move_onto_self(self):
         tree = self.make_branch_and_tree('.')
@@ -223,6 +235,7 @@
 
         self.assertRaises(errors.BzrMoveFailedError,
                           tree.move, ['b/a'], 'b')
+        tree._validate()
 
     def test_move_onto_self_root(self):
         tree = self.make_branch_and_tree('.')
@@ -232,6 +245,7 @@
 
         self.assertRaises(errors.BzrMoveFailedError,
                           tree.move, ['a'], 'a')
+        tree._validate()
 
     def test_move_after(self):
         tree = self.make_branch_and_tree('.')
@@ -251,6 +265,7 @@
                               tree)
         self.assertTreeLayout([('', root_id), ('a', 'a-id'), ('b', 'b-id')],
                               tree.basis_tree())
+        tree._validate()
 
     def test_move_after_with_after(self):
         tree = self.make_branch_and_tree('.')
@@ -269,6 +284,7 @@
                               tree)
         self.assertTreeLayout([('', root_id), ('a', 'a-id'), ('b', 'b-id')],
                               tree.basis_tree())
+        tree._validate()
 
     def test_move_after_no_target(self):
         tree = self.make_branch_and_tree('.')
@@ -282,6 +298,7 @@
                           tree.move, ['a'], 'b', after=True)
         self.assertTreeLayout([('', root_id), ('a', 'a-id'), ('b', 'b-id')],
                               tree.basis_tree())
+        tree._validate()
 
     def test_move_after_source_and_dest(self):
         tree = self.make_branch_and_tree('.')
@@ -321,6 +338,7 @@
         # But it shouldn't actually move anything
         self.assertFileEqual(a_text, 'a')
         self.assertFileEqual(ba_text, 'b/a')
+        tree._validate()
 
     def test_move_directory(self):
         tree = self.make_branch_and_tree('.')
@@ -338,6 +356,7 @@
         self.assertTreeLayout([('', root_id), ('a', 'a-id'), ('e', 'e-id'),
                                ('a/b', 'b-id'), ('a/c', 'c-id'),
                                ('a/c/d', 'd-id')], tree.basis_tree())
+        tree._validate()
 
     def test_move_moved(self):
         """Moving a moved entry works as expected."""
@@ -360,3 +379,4 @@
                                ('c', 'c-id')], tree)
         self.assertTreeLayout([('', root_id), ('a', 'a-id'), ('c', 'c-id'),
                                ('a/b', 'b-id')], tree.basis_tree())
+        tree._validate()

=== modified file 'bzrlib/tests/workingtree_implementations/test_workingtree.py'
--- bzrlib/tests/workingtree_implementations/test_workingtree.py	2007-03-10 20:35:58 +0000
+++ bzrlib/tests/workingtree_implementations/test_workingtree.py	2007-03-23 01:41:37 +0000
@@ -128,7 +128,6 @@
         self.assertEqual('foo', relpath)
         self.assertEqual(wt.basedir + '/', local_base)
 
-
     def test_basic_relpath(self):
         # for comprehensive relpath tests, see whitebox.py.
         tree = self.make_branch_and_tree('.')

=== modified file 'bzrlib/trace.py'
--- bzrlib/trace.py	2007-01-30 10:51:38 +0000
+++ bzrlib/trace.py	2007-03-27 04:57:59 +0000
@@ -181,6 +181,8 @@
 
     The exception string representation is used as the error
     summary, unless msg is given.
+
+    Please see log_exception_quietly() for the replacement API.
     """
     if msg:
         error(msg)

=== modified file 'bzrlib/transform.py'
--- bzrlib/transform.py	2007-03-11 20:34:48 +0000
+++ bzrlib/transform.py	2007-03-26 19:39:14 +0000
@@ -738,17 +738,17 @@
         conflicts = self.find_conflicts()
         if len(conflicts) != 0:
             raise MalformedTransform(conflicts=conflicts)
-        limbo_inv = {}
         inv = self._tree.inventory
+        inventory_delta = []
         child_pb = bzrlib.ui.ui_factory.nested_progress_bar()
         try:
             child_pb.update('Apply phase', 0, 2)
-            self._apply_removals(inv, limbo_inv)
+            self._apply_removals(inv, inventory_delta)
             child_pb.update('Apply phase', 1, 2)
-            modified_paths = self._apply_insertions(inv, limbo_inv)
+            modified_paths = self._apply_insertions(inv, inventory_delta)
         finally:
             child_pb.finished()
-        self._tree._write_inventory(inv)
+        self._tree.apply_inventory_delta(inventory_delta)
         self.__done = True
         self.finalize()
         return _TransformResults(modified_paths)
@@ -757,7 +757,7 @@
         """Generate the limbo name of a file"""
         return pathjoin(self._limbodir, trans_id)
 
-    def _apply_removals(self, inv, limbo_inv):
+    def _apply_removals(self, inv, inventory_delta):
         """Perform tree operations that remove directory/inventory names.
         
         That is, delete files that are to be deleted, and put any files that
@@ -786,16 +786,12 @@
                         file_id = self._tree.inventory.root.file_id
                     else:
                         file_id = self.tree_file_id(trans_id)
-                    del inv[file_id]
-                elif trans_id in self._new_name or trans_id in self._new_parent:
-                    file_id = self.tree_file_id(trans_id)
-                    if file_id is not None:
-                        limbo_inv[trans_id] = inv[file_id]
-                        inv.remove_recursive_id(file_id)
+                    assert file_id is not None
+                    inventory_delta.append((path, None, file_id, None))
         finally:
             child_pb.finished()
 
-    def _apply_insertions(self, inv, limbo_inv):
+    def _apply_insertions(self, inv, inventory_delta):
         """Perform tree operations that insert directory/inventory names.
         
         That is, create any files that need to be created, and restore from
@@ -807,6 +803,7 @@
         child_pb = bzrlib.ui.ui_factory.nested_progress_bar()
         try:
             for num, (path, trans_id) in enumerate(new_paths):
+                new_entry = None
                 child_pb.update('adding file', num, len(new_paths))
                 try:
                     kind = self._new_contents[trans_id]
@@ -829,35 +826,51 @@
                     if kind is None:
                         kind = file_kind(self._tree.abspath(path))
                     if trans_id in self._new_reference_revision:
-                        entry = inventory.TreeReference(self._new_id[trans_id], 
+                        new_entry = inventory.TreeReference(
+                            self._new_id[trans_id],
                             self._new_name[trans_id], 
                             self.final_file_id(self._new_parent[trans_id]),
                             None, self._new_reference_revision[trans_id])
-                        inv.add(entry)
                     else:
-                        inv.add_path(path, kind, self._new_id[trans_id])
-                elif trans_id in self._new_name or trans_id in\
-                    self._new_parent:
-                    entry = limbo_inv.get(trans_id)
-                    if entry is not None:
-                        entry.name = self.final_name(trans_id)
-                        parent_path = os.path.dirname(path)
-                        entry.parent_id = \
-                            self._tree.inventory.path2id(parent_path)
-                        inv.add(entry)
-
-                # requires files and inventory entries to be in place
+                        new_entry = inventory.make_entry(kind,
+                            self.final_name(trans_id),
+                            self.final_file_id(self.final_parent(trans_id)),
+                            self._new_id[trans_id])
+                else:
+                    if trans_id in self._new_name or trans_id in\
+                        self._new_parent or\
+                        trans_id in self._new_executability:
+                        file_id = self.final_file_id(trans_id)
+                        if file_id is not None:
+                            entry = inv[file_id]
+                            new_entry = entry.copy()
+
+                    if trans_id in self._new_name or trans_id in\
+                        self._new_parent:
+                            if new_entry is not None:
+                                new_entry.name = self.final_name(trans_id)
+                                parent = self.final_parent(trans_id)
+                                parent_id = self.final_file_id(parent)
+                                new_entry.parent_id = parent_id
+
                 if trans_id in self._new_executability:
-                    self._set_executability(path, inv, trans_id)
+                    self._set_executability(path, new_entry, trans_id)
+                if new_entry is not None:
+                    if new_entry.file_id in inv:
+                        old_path = inv.id2path(new_entry.file_id)
+                    else:
+                        old_path = None
+                    inventory_delta.append((old_path, path,
+                                            new_entry.file_id,
+                                            new_entry))
         finally:
             child_pb.finished()
         return modified_paths
 
-    def _set_executability(self, path, inv, trans_id):
+    def _set_executability(self, path, entry, trans_id):
         """Set the executability of versioned files """
-        file_id = inv.path2id(path)
         new_executability = self._new_executability[trans_id]
-        inv[file_id].executable = new_executability
+        entry.executable = new_executability
         if supports_executable():
             abspath = self._tree.abspath(path)
             current_mode = os.stat(abspath).st_mode

=== modified file 'bzrlib/transport/__init__.py'
--- bzrlib/transport/__init__.py	2007-03-28 03:02:32 +0000
+++ bzrlib/transport/__init__.py	2007-04-01 06:19:16 +0000
@@ -58,7 +58,11 @@
         zero_eight,
         zero_eleven,
         )
-from bzrlib.trace import mutter, warning
+from bzrlib.trace import (
+    note,
+    mutter,
+    warning,
+    )
 
 # {prefix: [transport_classes]}
 # Transports are inserted onto the list LIFO and tried in order; as a result
@@ -140,7 +144,7 @@
         for factory in factory_list:
             if factory.__module__ == "bzrlib.transport":
                 # this is a lazy load transport, because no real ones
-                # are directlry in bzrlib.transport
+                # are directly in bzrlib.transport
                 modules.add(factory.module)
             else:
                 modules.add(factory.__module__)
@@ -1053,6 +1057,48 @@
     return _try_transport_factories(base, _protocol_handlers[None])[0]
 
 
+def do_catching_redirections(action, transport, redirected):
+    """Execute an action with given transport catching redirections.
+
+    This is a facility provided for callers needing to follow redirections
+    silently. The silence is relative: it is the caller responsability to
+    inform the user about each redirection or only inform the user of a user
+    via the exception parameter.
+
+    :param action: A callable, what the caller want to do while catching
+                  redirections.
+    :param transport: The initial transport used.
+    :param redirected: A callable receiving the redirected transport and the 
+                  RedirectRequested exception.
+
+    :return: Whatever 'action' returns
+    """
+    MAX_REDIRECTIONS = 8
+
+    # If a loop occurs, there is little we can do. So we don't try to detect
+    # them, just getting out if too much redirections occurs. The solution
+    # is outside: where the loop is defined.
+    for redirections in range(MAX_REDIRECTIONS):
+        try:
+            return action(transport)
+        except errors.RedirectRequested, e:
+            redirection_notice = '%s is%s redirected to %s' % (
+                e.source, e.permanently, e.target)
+            transport = redirected(transport, e, redirection_notice)
+    else:
+        # Loop exited without resolving redirect ? Either the
+        # user has kept a very very very old reference or a loop
+        # occurred in the redirections.  Nothing we can cure here:
+        # tell the user. Note that as the user has been informed
+        # about each redirection (it is the caller responsibility
+        # to do that in redirected via the provided
+        # redirection_notice). The caller may provide more
+        # information if needed (like what file or directory we
+        # were trying to act upon when the redirection loop
+        # occurred).
+        raise errors.TooManyRedirections
+
+
 def _try_transport_factories(base, factory_list):
     last_err = None
     for factory in factory_list:
@@ -1178,6 +1224,7 @@
 register_lazy_transport(None, 'bzrlib.transport.local', 'LocalTransport')
 register_lazy_transport('file://', 'bzrlib.transport.local', 'LocalTransport')
 register_lazy_transport('sftp://', 'bzrlib.transport.sftp', 'SFTPTransport')
+# Decorated http transport
 register_lazy_transport('http+urllib://', 'bzrlib.transport.http._urllib',
                         'HttpTransport_urllib')
 register_lazy_transport('https+urllib://', 'bzrlib.transport.http._urllib',
@@ -1186,6 +1233,7 @@
                         'PyCurlTransport')
 register_lazy_transport('https+pycurl://', 'bzrlib.transport.http._pycurl',
                         'PyCurlTransport')
+# Default http transports (last declared wins (if it can be imported))
 register_lazy_transport('http://', 'bzrlib.transport.http._urllib',
                         'HttpTransport_urllib')
 register_lazy_transport('https://', 'bzrlib.transport.http._urllib',

=== modified file 'bzrlib/transport/http/__init__.py'
--- bzrlib/transport/http/__init__.py	2006-12-13 05:07:19 +0000
+++ bzrlib/transport/http/__init__.py	2007-03-13 16:27:30 +0000
@@ -143,7 +143,7 @@
             self._query, self._fragment) = urlparse.urlparse(self.base)
         self._qualified_proto = apparent_proto
         # range hint is handled dynamically throughout the life
-        # of the object. We start by trying mulri-range requests
+        # of the object. We start by trying multi-range requests
         # and if the server returns bougs results, we retry with
         # single range requests and, finally, we forget about
         # range if the server really can't understand. Once
@@ -226,17 +226,15 @@
         code, response_file = self._get(relpath, None)
         return response_file
 
-    def _get(self, relpath, ranges):
+    def _get(self, relpath, ranges, tail_amount=0):
         """Get a file, or part of a file.
 
         :param relpath: Path relative to transport base URL
-        :param byte_range: None to get the whole file;
-            or [(start,end)] to fetch parts of a file.
+        :param ranges: None to get the whole file;
+            or [(start,end)+], a list of tuples to fetch parts of a file.
+        :param tail_amount: The amount to get from the end of the file.
 
         :returns: (http_code, result_file)
-
-        Note that the current http implementations can only fetch one range at
-        a time through this call.
         """
         raise NotImplementedError(self._get)
 

=== modified file 'bzrlib/transport/http/_pycurl.py'
--- bzrlib/transport/http/_pycurl.py	2007-03-01 03:08:30 +0000
+++ bzrlib/transport/http/_pycurl.py	2007-03-13 17:00:20 +0000
@@ -23,6 +23,14 @@
 # whether we expect a particular file will be modified after it's committed.
 # It's probably safer to just always revalidate.  mbp 20060321
 
+# TODO: Some refactoring could be done to avoid the strange idiom
+# used to capture data and headers while setting up the request
+# (and having to pass 'header' to _curl_perform to handle
+# redirections) . This could be achieved by creating a
+# specialized Curl object and returning code, headers and data
+# from _curl_perform.  Not done because we may deprecate pycurl in the
+# future -- vila 20070212
+
 import os
 from cStringIO import StringIO
 import sys
@@ -111,16 +119,19 @@
         # don't want the body - ie just do a HEAD request
         # This means "NO BODY" not 'nobody'
         curl.setopt(pycurl.NOBODY, 1)
+        # But we need headers to handle redirections
+        header = StringIO()
+        curl.setopt(pycurl.HEADERFUNCTION, header.write)
         # In some erroneous cases, pycurl will emit text on
         # stdout if we don't catch it (see InvalidStatus tests
         # for one such occurrence).
         blackhole = StringIO()
         curl.setopt(pycurl.WRITEFUNCTION, blackhole.write)
-        self._curl_perform(curl)
+        self._curl_perform(curl, header)
         code = curl.getinfo(pycurl.HTTP_CODE)
         if code == 404: # not found
             return False
-        elif code in (200, 302): # "ok", "found"
+        elif code == 200: # "ok"
             return True
         else:
             self._raise_curl_http_error(curl)
@@ -165,7 +176,7 @@
         """Make a request for the entire file"""
         curl = self._curl
         abspath, data, header = self._setup_get_request(curl, relpath)
-        self._curl_perform(curl)
+        self._curl_perform(curl, header)
 
         code = curl.getinfo(pycurl.HTTP_CODE)
         data.seek(0)
@@ -188,8 +199,9 @@
             # Forget ranges, the server can't handle them
             return self._get_full(relpath)
 
-        self._curl_perform(curl, ['Range: bytes=%s'
-                                  % self.range_header(ranges, tail_amount)])
+        self._curl_perform(curl, header,
+                           ['Range: bytes=%s'
+                            % self.range_header(ranges, tail_amount)])
         data.seek(0)
 
         code = curl.getinfo(pycurl.HTTP_CODE)
@@ -210,7 +222,7 @@
         abspath, data, header = self._setup_request(curl, '.bzr/smart')
         # We override the Expect: header so that pycurl will send the POST
         # body immediately.
-        self._curl_perform(curl,['Expect: '])
+        self._curl_perform(curl, header, ['Expect: '])
         data.seek(0)
         code = curl.getinfo(pycurl.HTTP_CODE)
         headers = _extract_headers(header.getvalue(), abspath)
@@ -238,11 +250,10 @@
         # TODO: maybe include a summary of the pycurl version
         ua_str = 'bzr/%s (pycurl)' % (bzrlib.__version__,)
         curl.setopt(pycurl.USERAGENT, ua_str)
-        curl.setopt(pycurl.FOLLOWLOCATION, 1) # follow redirect responses
         if self.cabundle:
             curl.setopt(pycurl.CAINFO, self.cabundle)
 
-    def _curl_perform(self, curl, more_headers=[]):
+    def _curl_perform(self, curl, header, more_headers=[]):
         """Perform curl operation and translate exceptions."""
         try:
             # There's no way in http/1.0 to say "must
@@ -275,6 +286,15 @@
             # jam 20060713 The code didn't use to re-raise the exception here,
             # but that seemed bogus
             raise
+        code = curl.getinfo(pycurl.HTTP_CODE)
+        if code in (301, 302, 303, 307):
+            url = curl.getinfo(pycurl.EFFECTIVE_URL)
+            headers = _extract_headers(header.getvalue(), url)
+            redirected_to = headers['Location']
+            raise errors.RedirectRequested(url,
+                                           redirected_to,
+                                           is_permament=(code == 301),
+                                           qual_proto=self._qualified_proto)
 
 
 def get_test_permutations():

=== modified file 'bzrlib/transport/http/_urllib.py'
--- bzrlib/transport/http/_urllib.py	2006-12-21 13:37:29 +0000
+++ bzrlib/transport/http/_urllib.py	2007-02-12 14:02:01 +0000
@@ -16,8 +16,10 @@
 
 from cStringIO import StringIO
 
-from bzrlib import ui
-from bzrlib.errors import NoSuchFile
+from bzrlib import (
+    ui,
+    errors,
+    )
 from bzrlib.trace import mutter
 from bzrlib.transport import register_urlparse_netloc_protocol
 from bzrlib.transport.http import HttpTransportBase
@@ -107,9 +109,15 @@
             self._user = request.user
             self._password = request.password
 
+        code = response.code
+        if request.follow_redirections is False \
+                and code in (301, 302, 303, 307):
+            raise errors.RedirectRequested(request.get_full_url(),
+                                           request.redirected_to,
+                                           is_permament=(code == 301),
+                                           qual_proto=self._qualified_proto)
+
         if request.redirected_to is not None:
-            # TODO: Update the transport so that subsequent
-            # requests goes directly to the right host
             mutter('redirected from: %s to: %s' % (request.get_full_url(),
                                                    request.redirected_to))
 
@@ -132,7 +140,7 @@
         code = response.code
         if code == 404: # not found
             self._connection.fake_close()
-            raise NoSuchFile(abspath)
+            raise errors.NoSuchFile(abspath)
 
         data = handle_response(abspath, code, response.headers, response)
         # Close response to free the httplib.HTTPConnection pipeline
@@ -171,12 +179,10 @@
         response = self._head(relpath)
 
         code = response.code
-        # FIXME: 302 MAY have been already processed by the
-        # redirection handler
-        if code in (200, 302): # "ok", "found"
+        if code == 200: # "ok",
             return True
         else:
-            assert(code == 404, 'Only 200, 404 or may be 302 are correct')
+            assert(code == 404, 'Only 200 or 404 are correct')
             return False
 
 

=== modified file 'bzrlib/transport/http/_urllib2_wrappers.py'
--- bzrlib/transport/http/_urllib2_wrappers.py	2007-02-25 12:10:53 +0000
+++ bzrlib/transport/http/_urllib2_wrappers.py	2007-03-14 16:39:24 +0000
@@ -156,6 +156,8 @@
         # To handle redirections
         self.parent = parent
         self.redirected_to = None
+        # Unless told otherwise, redirections are not followed
+        self.follow_redirections = False
 
     def extract_auth(self, url):
         """Extracts authentification information from url.
@@ -501,11 +503,11 @@
         # of creating a new one, but the urllib2.Request object
         # has a too complicated creation process to provide a
         # simple enough equivalent update process. Instead, when
-        # redirecting, we only update the original request with a
-        # reference to the following request in the redirect
-        # chain.
+        # redirecting, we only update the following request in
+        # the redirect chain with a reference to the parent
+        # request .
 
-        # Some codes make no sense on out context and are treated
+        # Some codes make no sense in our context and are treated
         # as errors:
 
         # 300: Multiple choices for different representations of
@@ -520,11 +522,10 @@
 
         # 306: Unused (if the RFC says so...)
 
-        # FIXME: If the code is 302 and the request is HEAD, we
-        # MAY avoid following the redirections if the intent is
-        # to check the existence, we have a hint that the file
-        # exist, now if we want to be sure, we must follow the
-        # redirection. Let's do that for now.
+        # If the code is 302 and the request is HEAD, some may
+        # think that it is a sufficent hint that the file exists
+        # and that we MAY avoid following the redirections. But
+        # if we want to be sure, we MUST follow them.
 
         if code in (301, 302, 303, 307):
             return Request(req.get_method(),newurl,
@@ -541,7 +542,7 @@
         else:
             raise urllib2.HTTPError(req.get_full_url(), code, msg, headers, fp)
 
-    def http_error_30x(self, req, fp, code, msg, headers):
+    def http_error_302(self, req, fp, code, msg, headers):
         """Requests the redirected to URI.
 
         Copied from urllib2 to be able to fake_close the
@@ -561,7 +562,12 @@
         else:
             return
         if self._debuglevel > 0:
-            print 'Redirected to: %s' % newurl
+            print 'Redirected to: %s (followed: %r)' % (newurl,
+                                                        req.follow_redirections)
+        if req.follow_redirections is False:
+            req.redirected_to = newurl
+            return fp
+
         newurl = urlparse.urljoin(req.get_full_url(), newurl)
 
         # This call succeeds or raise an error. urllib2 returns
@@ -590,23 +596,7 @@
 
         return self.parent.open(redirected_req)
 
-    http_error_302 = http_error_303 = http_error_307 = http_error_30x
-
-    def http_error_301(self, req, fp, code, msg, headers):
-        response = self.http_error_30x(req, fp, code, msg, headers)
-        # If one or several 301 response occur during the
-        # redirection chain, we MUST update the original request
-        # to indicate where the URI where finally found.
-
-        original_req = req
-        while original_req.parent is not None:
-            original_req = original_req.parent
-            if original_req.redirected_to is None:
-                # Only the last occurring 301 should be taken
-                # into account i.e. the first occurring here when
-                # redirected_to has not yet been set.
-                original_req.redirected_to = redirected_url
-        return response
+    http_error_301 = http_error_303 = http_error_307 = http_error_302
 
 
 class ProxyHandler(urllib2.ProxyHandler):

=== modified file 'bzrlib/transport/smart.py'
--- bzrlib/transport/smart.py	2007-03-28 07:33:07 +0000
+++ bzrlib/transport/smart.py	2007-04-05 06:59:17 +0000
@@ -195,6 +195,7 @@
 #
 
 from cStringIO import StringIO
+import errno
 import os
 import socket
 import sys
@@ -212,6 +213,7 @@
     urlutils,
     )
 from bzrlib.bundle.serializer import write_bundle
+from bzrlib.hooks import Hooks
 try:
     from bzrlib.transport import ssh
 except errors.ParamikoNotPresent:
@@ -820,7 +822,10 @@
 
 
 class SmartTCPServer(object):
-    """Listens on a TCP socket and accepts connections from smart clients"""
+    """Listens on a TCP socket and accepts connections from smart clients
+
+    hooks: An instance of SmartServerHooks.
+    """
 
     def __init__(self, backing_transport, host='127.0.0.1', port=0):
         """Construct a new server.
@@ -831,36 +836,67 @@
         :param host: Name of the interface to listen on.
         :param port: TCP port to listen on, or 0 to allocate a transient port.
         """
-        self._server_socket = socket.socket()
-        self._server_socket.bind((host, port))
-        self.port = self._server_socket.getsockname()[1]
-        self._server_socket.listen(1)
-        self._server_socket.settimeout(1)
-        self.backing_transport = backing_transport
-
-    def serve(self):
         # let connections timeout so that we get a chance to terminate
         # Keep a reference to the exceptions we want to catch because the socket
         # module's globals get set to None during interpreter shutdown.
         from socket import timeout as socket_timeout
         from socket import error as socket_error
+        self._socket_error = socket_error
+        self._socket_timeout = socket_timeout
+        self._server_socket = socket.socket()
+        self._server_socket.bind((host, port))
+        self._sockname = self._server_socket.getsockname()
+        self.port = self._sockname[1]
+        self._server_socket.listen(1)
+        self._server_socket.settimeout(1)
+        self.backing_transport = backing_transport
+        self._started = threading.Event()
+        self._stopped = threading.Event()
+
+    def serve(self):
         self._should_terminate = False
-        while not self._should_terminate:
-            try:
-                self.accept_and_serve()
-            except socket_timeout:
-                # just check if we're asked to stop
-                pass
-            except socket_error, e:
-                trace.warning("client disconnected: %s", e)
-                pass
+        for hook in SmartTCPServer.hooks['server_started']:
+            hook(self.backing_transport.base, self.get_url())
+        self._started.set()
+        try:
+            try:
+                while not self._should_terminate:
+                    try:
+                        conn, client_addr = self._server_socket.accept()
+                    except self._socket_timeout:
+                        # just check if we're asked to stop
+                        pass
+                    except self._socket_error, e:
+                        # if the socket is closed by stop_background_thread
+                        # we might get a EBADF here, any other socket errors
+                        # should get logged.
+                        if e.args[0] != errno.EBADF:
+                            trace.warning("listening socket error: %s", e)
+                    else:
+                        self.serve_conn(conn)
+            except KeyboardInterrupt:
+                # dont log when CTRL-C'd.
+                raise
+            except Exception, e:
+                trace.error("Unhandled smart server error.")
+                trace.log_exception_quietly()
+                raise
+        finally:
+            self._stopped.set()
+            try:
+                # ensure the server socket is closed.
+                self._server_socket.close()
+            except self._socket_error:
+                # ignore errors on close
+                pass
+            for hook in SmartTCPServer.hooks['server_stopped']:
+                hook(self.backing_transport.base, self.get_url())
 
     def get_url(self):
         """Return the url of the server"""
-        return "bzr://%s:%d/" % self._server_socket.getsockname()
+        return "bzr://%s:%d/" % self._sockname
 
-    def accept_and_serve(self):
-        conn, client_addr = self._server_socket.accept()
+    def serve_conn(self, conn):
         # For WIN32, where the timeout value from the listening socket
         # propogates to the newly accepted socket.
         conn.setblocking(True)
@@ -871,20 +907,60 @@
         connection_thread.start()
 
     def start_background_thread(self):
+        self._started.clear()
         self._server_thread = threading.Thread(None,
                 self.serve,
                 name='server-' + self.get_url())
         self._server_thread.setDaemon(True)
         self._server_thread.start()
+        self._started.wait()
 
     def stop_background_thread(self):
+        self._stopped.clear()
+        # tell the main loop to quit on the next iteration.
         self._should_terminate = True
-        # At one point we would wait to join the threads here, but it looks
-        # like they don't actually exit.  So now we just leave them running
-        # and expect to terminate the process. -- mbp 20070215
-        # self._server_socket.close()
-        ## sys.stderr.write("waiting for server thread to finish...")
-        ## self._server_thread.join()
+        # close the socket - gives error to connections from here on in,
+        # rather than a connection reset error to connections made during
+        # the period between setting _should_terminate = True and 
+        # the current request completing/aborting. It may also break out the
+        # main loop if it was currently in accept() (on some platforms).
+        try:
+            self._server_socket.close()
+        except self._socket_error:
+            # ignore errors on close
+            pass
+        if not self._stopped.isSet():
+            # server has not stopped (though it may be stopping)
+            # its likely in accept(), so give it a connection
+            temp_socket = socket.socket()
+            temp_socket.setsockopt(socket.IPPROTO_TCP, socket.TCP_NODELAY, 1)
+            if not temp_socket.connect_ex(self._sockname):
+                # and close it immediately: we dont choose to send any requests.
+                temp_socket.close()
+        self._stopped.wait()
+        self._server_thread.join()
+
+
+class SmartServerHooks(Hooks):
+    """Hooks for the smart server."""
+
+    def __init__(self):
+        """Create the default hooks.
+
+        These are all empty initially, because by default nothing should get
+        notified.
+        """
+        Hooks.__init__(self)
+        # Introduced in 0.16:
+        # invoked whenever the server starts serving a directory.
+        # The api signature is (backing url, public url).
+        self['server_started'] = []
+        # Introduced in 0.16:
+        # invoked whenever the server stops serving a directory.
+        # The api signature is (backing url, public url).
+        self['server_stopped'] = []
+
+SmartTCPServer.hooks = SmartServerHooks()
 
 
 class SmartTCPServer_for_testing(SmartTCPServer):

=== modified file 'bzrlib/ui/__init__.py'
--- bzrlib/ui/__init__.py	2007-02-21 14:46:06 +0000
+++ bzrlib/ui/__init__.py	2007-03-23 01:41:37 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -36,6 +36,7 @@
 
 from bzrlib import (
     progress,
+    trace,
     )
 """)
 
@@ -97,7 +98,20 @@
         """
         raise NotImplementedError(self.get_boolean)
 
+    def recommend_upgrade(self,
+        current_format_name,
+        basedir):
+        # this should perhaps be in the TextUIFactory and the default can do
+        # nothing
+        trace.warning("%s is deprecated "
+            "and a better format is available.\n"
+            "It is recommended that you upgrade by "
+            "running the command\n"
+            "  bzr upgrade %s",
+            current_format_name,
+            basedir)
 
+            
 class CLIUIFactory(UIFactory):
     """Common behaviour for command line UI factories."""
 
@@ -162,6 +176,9 @@
     def clear_term(self):
         pass
 
+    def recommend_upgrade(self, *args):
+        pass
+
 
 def clear_decorator(func, *args, **kwargs):
     """Decorator that clears the term"""

=== modified file 'bzrlib/version.py'
--- bzrlib/version.py	2007-03-12 06:02:37 +0000
+++ bzrlib/version.py	2007-03-23 21:46:46 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2006 Canonical Ltd
+# Copyright (C) 2004, 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,7 +20,12 @@
 import sys
 
 import bzrlib
-from bzrlib import config, errors, osutils
+from bzrlib import (
+    bzrdir,
+    config,
+    errors,
+    osutils,
+    )
 from bzrlib.branch import Branch
 
 
@@ -61,8 +66,8 @@
     If bzr is not being run from its working tree, returns None.
     """
     try:
-        from bzrlib.workingtree import WorkingTree
-        return WorkingTree.open_containing(__file__)[0]
+        control = bzrdir.BzrDir.open_containing(__file__)[0]
+        return control.open_workingtree(recommend_upgrade=False)
     except (errors.NotBranchError, errors.UnknownFormatError,
             errors.NoWorkingTree):
         return None

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2007-03-30 02:36:36 +0000
+++ bzrlib/workingtree.py	2007-04-01 06:19:16 +0000
@@ -68,7 +68,9 @@
     revisiontree,
     repository,
     textui,
+    trace,
     transform,
+    ui,
     urlutils,
     xml5,
     xml6,
@@ -1393,7 +1395,7 @@
         # prevent race conditions with the lock
         return iter(
             [subp for subp in self.extras() if not self.is_ignored(subp)])
-    
+
     @needs_tree_write_lock
     def unversion(self, file_ids):
         """Remove the file ids in file_ids from the current versioned set.
@@ -2263,6 +2265,17 @@
         self.set_conflicts(un_resolved)
         return un_resolved, resolved
 
+    def _validate(self):
+        """Validate internal structures.
+
+        This is meant mostly for the test suite. To give it a chance to detect
+        corruption after actions have occurred. The default implementation is a
+        just a no-op.
+
+        :return: None. An exception should be raised if there is an error.
+        """
+        return
+
 
 class WorkingTree2(WorkingTree):
     """This is the Format 2 working tree.
@@ -2428,6 +2441,8 @@
 
     requires_rich_root = False
 
+    upgrade_recommended = False
+
     @classmethod
     def find_format(klass, a_bzrdir):
         """Return the format for the working tree object in a_bzrdir."""
@@ -2482,13 +2497,14 @@
         del klass._formats[format.get_format_string()]
 
 
-
 class WorkingTreeFormat2(WorkingTreeFormat):
     """The second working tree format. 
 
     This format modified the hash cache from the format 1 hash cache.
     """
 
+    upgrade_recommended = True
+
     def get_format_description(self):
         """See WorkingTreeFormat.get_format_description()."""
         return "Working tree format 2"
@@ -2557,11 +2573,11 @@
             raise NotImplementedError
         if not isinstance(a_bzrdir.transport, LocalTransport):
             raise errors.NotLocalUrl(a_bzrdir.transport.base)
-        return WorkingTree2(a_bzrdir.root_transport.local_abspath('.'),
+        wt = WorkingTree2(a_bzrdir.root_transport.local_abspath('.'),
                            _internal=True,
                            _format=self,
                            _bzrdir=a_bzrdir)
-
+        return wt
 
 class WorkingTreeFormat3(WorkingTreeFormat):
     """The second working tree format updated to record a format marker.
@@ -2574,6 +2590,8 @@
         - is new in bzr 0.8
         - uses a LockDir to guard access for writes.
     """
+    
+    upgrade_recommended = True
 
     def get_format_string(self):
         """See WorkingTreeFormat.get_format_string()."""
@@ -2664,7 +2682,8 @@
             raise NotImplementedError
         if not isinstance(a_bzrdir.transport, LocalTransport):
             raise errors.NotLocalUrl(a_bzrdir.transport.base)
-        return self._open(a_bzrdir, self._open_control_files(a_bzrdir))
+        wt = self._open(a_bzrdir, self._open_control_files(a_bzrdir))
+        return wt
 
     def _open(self, a_bzrdir, control_files):
         """Open the tree itself.

=== modified file 'bzrlib/workingtree_4.py'
--- bzrlib/workingtree_4.py	2007-03-22 19:54:30 +0000
+++ bzrlib/workingtree_4.py	2007-03-31 03:19:39 +0000
@@ -563,7 +563,7 @@
                 # set our support for tree references from the repository in
                 # use.
                 self._repo_supports_tree_reference = getattr(
-                    self.branch.repository._format, "support_tree_reference",
+                    self.branch.repository._format, "supports_tree_reference",
                     False)
             except:
                 self._control_files.unlock()
@@ -583,7 +583,7 @@
                 # set our support for tree references from the repository in
                 # use.
                 self._repo_supports_tree_reference = getattr(
-                    self.branch.repository._format, "support_tree_reference",
+                    self.branch.repository._format, "supports_tree_reference",
                     False)
             except:
                 self._control_files.unlock()
@@ -809,7 +809,7 @@
                                      size=cur_details[2],
                                      to_block=to_block,
                                      to_key=to_key,
-                                     to_path_utf8=to_rel_utf8)
+                                     to_path_utf8=to_path_utf8)
                             if minikind == 'd':
                                 # We need to move all the children of this
                                 # entry
@@ -1202,6 +1202,10 @@
             for file_id in file_ids:
                 self._inventory.remove_recursive_id(file_id)
 
+    @needs_read_lock
+    def _validate(self):
+        self._dirstate._validate()
+
     @needs_tree_write_lock
     def _write_inventory(self, inv):
         """Write inventory as the current inventory."""
@@ -1225,6 +1229,8 @@
         - uses a LockDir to guard access to it.
     """
 
+    upgrade_recommended = False
+
     def get_format_string(self):
         """See WorkingTreeFormat.get_format_string()."""
         return "Bazaar Working Tree Format 4 (bzr 0.15)\n"
@@ -1256,6 +1262,7 @@
         # write out new dirstate (must exist when we create the tree)
         state = dirstate.DirState.initialize(local_path)
         state.unlock()
+        del state
         wt = WorkingTree4(a_bzrdir.root_transport.local_abspath('.'),
                          branch,
                          _format=self,
@@ -1263,7 +1270,7 @@
                          _control_files=control_files)
         wt._new_tree()
         wt.lock_tree_write()
-        state._validate()
+        wt.current_dirstate()._validate()
         try:
             if revision_id in (None, NULL_REVISION):
                 wt._set_root_id(generate_ids.gen_root_id())

=== modified file 'doc/tutorial.txt'
--- doc/tutorial.txt	2007-03-02 12:40:45 +0000
+++ doc/tutorial.txt	2007-04-03 22:58:12 +0000
@@ -122,12 +122,12 @@
 
     To set a global identity, use::
  
-    % bzr whoami 'Your Name <email@example.com>'
+    % bzr whoami "Your Name <email@example.com>"
  
     If you'd like to use a different address for a specific branch, enter
     the branch folder and use::
  
-    % bzr whoami --branch 'Your Name <email@example.com>'
+    % bzr whoami --branch "Your Name <email@example.com>"
  
  #. Setting the email address in the ``~/.bazaar/bazaar.conf`` [1]_ by adding the following lines.
     Please note that  ``[DEFAULT]`` is case sensitive::

